/'
'#####################################################################
'# This program is free software; you can redistribute it and/or     #
'# modify it under the terms of the GNU General Public License       #
'# as published by the Free Software Foundation; either version 3    #
'# of the License, or (at your option) any later version.            #
'#                                                                   #
'# This program is distributed in the hope that it will be useful,   #
'# but WITHOUT ANY WARRANTY; without even the implied warranty of    #
'# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     #
'# GNU General Public License for more details.                      #
'#                                                                   #
'# You should have received a copy of the GNU General Public License #
'# along with this program; if not, write to the Free Software       #
'# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,        #
'# MA  02110-1301, USA.                                              #
'#####################################################################

'convenes de nomenclatura:
'functionNamesLikeThis
'variable_names_like_this
'CONST_NAMES_LIKE_THIS (exceto true e false)
'typenameslikethis
'sub calls, like, this
'= function(calls, like, this)
'declare sub whatever (like, this)
'dim one_variable as integer
'dim some_pointer as integer ptr
'dim as integer one_variable, two_variables, three_variables
'dim as integer initialized_variable = 1
'some_array(0)

'tamanho do tab: 4 chars

'Changelog:
'Verso 1.0 (24/08/10) - Terminado o jogo para o curso de IDJ e o festival SBGames
'Verso 1.1 (18/10/10) - Adicionado modo demonstrao para exposio na Semana de Cincia e Tecnologia
'Verso 1.2 (03/11/11) - Nova opo: controle de estabilidade, simplifica a pilotagem para jogadores iniciantes.
'                        Outras alteraes:
'                          * Removido o texto da UnB da tela inicial
'                          * Corrigido espelhamento do cavalinho da Scirocco
'/

#include "SDL/SDL.bi"
#include "SDL/SDL_image.bi"
#include "al/al.bi"
#include "al/alut.bi"
#include "vorbis/codec.bi"
#include "vorbis/vorbisenc.bi"
#include "vorbis/vorbisfile.bi"
#include "crt/stdio.bi"

'declara constantes
const as integer false = 0
const as integer true = not false
const as double  PI = 3.141596
const as integer OUTRUN_WARP = false	'desligue se o jogo te deixar tonto!
const as integer BRILHO_NEVOA = 160		'0-255
const as integer VEL_FADE = 12			'0-255
const as integer TELA_BPP = 32			'sempre 32 nesse jogo!
const as single  VOL_MUSICA = 0.6		'0-1
const as integer BUFFER_VORBIS = 32768	'valores maiores gastam mais memria, menos chance de engasgar
const as integer MENU_TIMEOUT = 20000	'ms para entrada do demo
const as integer DEMO_TIMEOUT = 120000	'ms para voltar ao menu
const as integer MAX_SPRITES = 50		'mximo de sprites que aparecem na tela ao mesmo tempo
const as integer MAX_CARROS = 3			'cuidado: os valores daqui pra baixo definem a dimenso dos arrays
const as integer MAX_CIRCUITOS = 6
const as integer MAX_TEXTURAS = 4
const as integer MAX_DECORS = 7
const as integer MAX_PALETES = 7
const as integer MAX_PAL_COLORS = 30
const as integer MAX_FONT_COLORS = 5
const as integer MAX_FONT_CHARS = 66
const as integer MAX_MENU_ITEMS = 14
const as integer MAX_CC = 49
const as integer MAX_NITROS = 2
const as integer MAX_EVENTOS = 11
const as integer MAX_TECLAS = 8

'declara objetos
type tupla
	x as integer
	y as integer
end type	

type imagem
	private:
		surface as SDL_Surface ptr
		fullscreen as byte
			
	public:
		const as integer FX_PRETO_E_BRANCO = 0
		const as integer FX_ESCURECE = 1
		const as integer FX_NEVOA = 2
		const as integer FX_NULL = 3
	
		'primitivas grficas
		declare function getSurface () as SDL_Surface ptr
		declare function getDimensoes () as tupla
		declare function getFullscreen () as byte
		declare function getPitch () as integer
		declare function getBPP () as integer
		declare function getPixel (x as integer, y as integer) as uinteger		'perigoso: depende do formato de pixel
		declare sub pintaPixel (offset as integer, cor as uinteger)				'NO tem deteco de boundaries!
		declare sub pintaPixel (x as integer, y as integer, cor as uinteger)	'para ser seguro, usar pintaLinha x, y, x, y
		declare sub pintaLinha (x1 as integer, y1 as integer, x2 as integer, y2 as integer, cor as uinteger)
		declare sub pintaSprite (sprite as imagem, x as integer, y as integer)
		declare sub pintaSprite (sprite as imagem, x as integer, y as integer, transparencia as ubyte)
		declare sub copiaSprite (sprite as imagem, x1 as integer, y1 as integer, x2 as integer, y2 as integer)
			
		'efeitos do jogo
		declare sub aplicaPalete (pal_origem as integer, pal_destino as integer)
		declare function efeitoCor (cor as uinteger, efeito as integer, amount as ubyte) as uinteger
		declare function efeitoCor (cor as uinteger, efeito as integer) as uinteger
		declare sub efeitoSprite (efeito as integer, fator as single)
		declare sub efeitoTela (efeito as integer, amount as ubyte)
		
		'tela principal
		declare sub setIcone (sprite as imagem)
		declare sub setRes (w as integer, h as integer, fullscreen as integer)
		declare sub pixelDoubling ()
		declare sub atualiza ()
		declare sub trava ()							'para acesso direto  memria (no tem perigo j que no uso threads?)
		declare sub destrava ()							'||
		
		declare sub cria (w as integer, h as integer)	'cria uma imagem vazia
		declare sub carrega (arquivo as string)			'cria e carrega do arquivo
		declare sub destroi ()							'libera da memria
end type

type palete
	private:
		nome (0 to MAX_PALETES) as string
		cor (0 to MAX_PALETES, 0 to MAX_PAL_COLORS) as uinteger
		preview (0 to MAX_PALETES) as imagem
	
	public:
		declare function getNome (i as integer) as string
		declare function getCor (i as integer, j as integer) as uinteger
		declare function match (i as integer, j as integer, cor as uinteger) as integer
		
		declare sub carrega (arquivo as string)
		declare sub pintaPreview (i as integer, x as integer, y as integer) 
		declare sub destroi ()
end type

type fonte
	private:
		alfanumerico (0 to MAX_FONT_COLORS, 0 to MAX_FONT_CHARS) as imagem
		numeral (0 to 9) as imagem
		
	public:
		declare sub pinta (x as integer, y as integer, texto as string, cor as integer)
		declare sub pinta (x as integer, y as integer, texto as string, cor as integer, sombreado as integer)
		declare sub mensagem (texto as string, cor as integer)
		declare sub pintaNumero (x as integer, y as integer, texto as string)
		
		declare sub carrega (arquivo1 as string, arquivo2 as string)
		declare sub destroi ()
end type

type som
	private:
		buffer as ALuint
		source as ALuint
				
	public:
		declare sub toca ()
		declare sub para ()
		declare sub setLoop (is_true as integer)
		declare sub setPitch (pitch as ALfloat)
		declare sub setPan (pan as ALfloat)
		declare sub setVolume (volume as ALfloat)
	
		declare sub carrega (arquivo as string)
		declare sub destroi ()
end type

type musica
	private:
		buffer(0 to 1)	as ALuint
		source			as ALuint
		formato			as ALenum
		
		ogg_file		as FILE ptr
		ogg_stream		as OggVorbis_File
		ogg_info		as vorbis_info ptr
		tocando			as byte	
				
		declare function carregaBuffer (buffer_atual as ALuint) as integer	'retorna false se o stream acabou
		declare function atualiza () as integer								'passa o retorno de carregaBuffer
		declare sub pausa ()
		
	public:
		declare function toca () as integer									'retorna false se no houver mais o que tocar
		declare sub setVolume (volume as ALfloat)							'valor de fade (0-1) relativo a VOL_MUSICA
		
		declare sub carrega (arquivo as string)
		declare sub destroi ()
end type

type tempos
	private:
		ms (0 to 5) as double
		
		volta_atual as integer
		recorde_voltas as integer
	
	public:
		const as integer VOLTA = 0
		const as integer ULTIMA = 1
		const as integer MELHOR = 2
		const as integer META = 3
		const as integer RECORDE = 4
		const as integer TOTAL = 5
	
		declare function getMS (i as integer) as double
		declare function getVolta () as integer
		declare function getRecordeVoltas () as integer
		declare function pisca () as integer
		declare function formata (t as longint) as string
		declare sub pintaHUD ()
		
		declare sub reinicia ()
		declare sub atualiza ()

end type

type framerate
	private:
		fator as double
		fps as double
		
		old_timer as double
		timer_dif as double
		
		max_fps as integer
	
	public:
		declare function getFator () as double
		declare function getFPS () as string
		declare function getMaxFPS () as integer
		declare sub setMaxFPS (max_fps as integer)
		
		declare sub reinicia ()
		declare sub atualiza ()
		declare sub preciseSleep ()
end type

type eventos
	private:
		status (0 to MAX_EVENTOS) as integer
		
	public:	
		const as integer GAME_OVER = 0
		const as integer COLISAO = 1
		const as integer BUMP = 2
		const as integer ULTRAPASSAGEM = 3
		const as integer GRAMA = 4
		const as integer PRE_DERRAPAGEM = 5
		const as integer DERRAPAGEM = 6
		const as integer FREIO = 7
		const as integer COMPLETA_VOLTA = 8
		const as integer COLETA_NITRO = 9
		const as integer GASTA_NITRO = 10
		const as integer AUTO_PILOT = 11
		
		declare function getStatus (i as integer) as integer
		declare sub setStatus (i as integer, status as integer)
		
		declare sub reinicia()
end type

type controle
	private:
		key_state as ubyte ptr
		tecla (0 to MAX_TECLAS) as integer
		last_tecla (0 to MAX_TECLAS) as integer
		
	public:
		const as integer DOWN = 0
		const as integer PRESSED = 1
		const as integer K_UP = 0
		const as integer K_DOWN = 1
		const as integer K_LEFT = 2
		const as integer K_RIGHT = 3
		const as integer K_MARCHA = 4
		const as integer K_NITRO = 5
		const as integer K_ESCOLHE = 6
		const as integer K_RETORNA = 7
		const as integer K_PAUSA = 8
			
		declare function confereTecla (i as integer, estado as integer) as integer
		declare sub atualiza ()
		declare sub esperaTecla ()
end type

type sprite3d
	i as integer 'ndice
	x as integer
	y as integer
	tam as integer 'largura
	tem_topo as integer 'para o sprite de tnel: apenas 1 lado precisa/pode desenhar
end type

type pilhasprites
	private:
		item (0 to MAX_SPRITES) as sprite3d
		ponteiro as integer
	
	public:
		declare function naoVazia () as integer
		
		declare sub nova ()
		declare sub push (i as integer, x as integer, y as integer, tam as integer, tem_topo as integer)
		declare sub push (i as integer, x as integer, y as integer, tam as integer)
		declare function pop () as sprite3d
end type

type imagem3d
	private:
		sprite (0 to 9) as imagem
		
	public:
		declare sub pintaDecor (spr as sprite3d)
		declare sub pintaCC (spr as sprite3d, transparencia as ubyte)
		declare sub pintaCC (spr as sprite3d)
				
		declare sub carregaDecor (arquivo as string)
		declare sub carregaCC (mdl_index as integer, palete as integer)
		declare sub destroi ()
end type

type modelo
	private:
		nome			as string
		fator_vel		as double	'velocidade final
		fator_grip		as double	'velocidade nas curvas
		
		palete_default	as integer
		luz_freio		as tupla	'coordenada grfica
		escapamento		as tupla	'||
		offset			as integer	'n de pixels que o carro desloca na animao	
				
	public:		
		const as integer FERRARI = 0
		const as integer FORD = 1
		const as integer PORSCHE = 2
		const as integer GOLF = 3
	
		declare function getNome () as string
		declare function getFatorVel () as double
		declare function getFatorGrip () as double
		declare function getPaleteDefault () as integer
		declare function getLuzFreio () as tupla
		declare function getEscapamento () as tupla
		declare function getOffset () as integer
				
		declare sub cria (i as integer) 'presets vo todos dentro do construtor
end type

type carro
	private:
		mdl_index	as integer	'ndice do modelo [mdl(i)]
		palete		as integer
		auto_gear	as integer	'true/false
		steer_aid	as integer	'true/false
	
		'variveis
		coord		as double		'1 = 1 setor = 1 caractere em circuito | decimal = posio no setor
		last_coord	as double
		
		vel				as double	'velocidade em coords
		acc				as double	'acelerao em vel
		
		x				as double	'-1 = fora da pista | 0 = centro | 1 = fora da pista
		accx			as double	'acelerao em x
		limiar			as double	'limiar de derrapagem em accx
		
		marcha			as integer	'0 = primeira | 1 = segunda
		rpm				as double
		
		ang				as double	'pseudo-ngulo do giro sobre o eixo do carro (0-1)
		nitros			as integer	'nitros acumulados
		tempo_nitro		as double	'contador para o fim do nitro
		
		'constantes
		inercia(0 to 1)	as double	'0 = resistncia total | 1 = resistncia nula
		acc_max(0 to 1)	as double	'torque da marcha (sobre acc)
		
		vel_limiar		as double	'velocidade que o carro comea a derrapar (sobre vel)
		
		x_lock			as double	'ngulo mximo de roda (sobre accx)
		x_step			as double	'velocidade do volante (sobre accx)
		x_center		as double	'velocidade da resposta do volante (sobre accx)
		
		'graficos
		sprite (0 to 2)			as imagem
		overlay (0 to 2)		as imagem
		farol					as imagem
		fumaca					as imagem
		ponteiro (0 to 19)		as imagem
		ponteiro_mask (0 to 2)	as imagem
		
		fumaca_fade				as integer	'animao de fumaa
		
	public:
		'interface		
		declare function getCoord () as double
		declare function getLastCoord () as double
		declare function getVel () as double
		declare function getX () as double
		declare function getRPM () as double
		declare function getAng () as double
		declare function getSprite () as imagem
		
		declare function getModelo () as integer
		declare sub setModelo (mdl_index as integer) 'construtor
		declare function getPalete () as integer
		declare sub setPalete (palete as integer)
		declare function getAutoGear () as integer
		declare sub setAutoGear (auto_gear as integer)
		declare function getSteerAid () as integer
		declare sub setSteerAid (steer_aid as integer)
		
		'mecnica
		declare sub reinicia ()
		declare sub controles ()
		declare sub fisica ()
		
		'grficos
		declare sub pintaSprite (x as integer)
		declare sub pintaOverlay (x as integer, y as integer, quadro as integer, i as integer)
		declare sub pintaHUD ()
		
		declare sub carrega (bypass_efeitos as integer)
		declare sub carrega ()
		declare sub destroi ()
end type

type carrocomp
	coord		as double	'mesmo que carro
	last_coord	as double
		
	vel			as double	'constante
	x			as double
	accx		as double	'constante
		
	timeout		as integer	'flag para evitar deteco de coliso nos dois sentidos
end type

type listacc
	private:
		item (0 to MAX_CC) as carrocomp
		max_itens as integer
	
		img as imagem3d 
	
	public:
		declare function getCoord (i as integer) as double
		declare function getX (i as integer) as double
		declare function getMaxItens () as integer
	
		declare sub spawn ()
		declare sub processa () 'movimento e coliso
end type

type nitros
	private:
		coord	(0 to MAX_NITROS) as double
		x		(0 to MAX_NITROS) as double
		ativo	(0 to MAX_NITROS) as double
		max_itens as integer
	
	public:
		declare function getCoord (i as integer) as double
		declare function getX (i as integer) as double
		declare function getAtivo (i as integer) as integer
		declare sub setAtivo (i as integer, ativo as integer)
		declare function getMaxItens () as integer
		
		declare sub spawn (nova_corrida as integer)
end type

type circuito
	private:
		nome			as string
		nome_completo	as string
		s				as string	'array de setores
				
		recorde			as double
		recorde_voltas	as integer
		
		media			as double	'fator para calcular o tempo de volta arcade (velocidade em coords)
		dificuldade		as double	'0-1: relativo a quantas voltas o jogo arcade dura
		nitros			as integer	'mximo de nitros por volta
		ang_step		as double	'velocidade de movimentao do horizonte
		
		grama			as uinteger	'cor da grama
		mar				as tupla	'x = inicio | y = fim | no existe: x = false
		mapa			as imagem
		bandeira		as imagem
		mapa_peq		as imagem
	
		index			as integer	'guarda para referncia
					
		declare function mirror (s as string) as string
		declare function reverse (s as string) as string
		declare sub calculaAngStep ()
	
	public:	
		const as integer SUBURBAN = 0
		const as integer MOUNTAIN = 1
		const as integer CITY = 2
		const as integer DESERT = 3
		const as integer ALPINE = 4
		const as integer NIGHT = 5
		const as integer FOG = 6
	
		declare function getNome () as string
		declare function getNomeCompleto () as string
		declare function getRecorde () as double
		declare function getRecordeVoltas () as integer
		declare function getMedia () as double
		declare function getDificuldade () as double
		declare function getNitros () as integer
		declare function getAngStep () as double
		declare function getGrama () as uinteger
		declare function getMar () as tupla
		declare function noite () as integer
		declare function neve () as integer
		declare function nevoa () as integer
		declare sub pintaMapa (x as integer, y as integer)
		declare function getSetores (orientacao as integer) as string '0 = original | 1 = mirrored | 2 = reversed | 3 = mirrored reversed
		
		declare sub cria (i as integer)
		declare sub carregaRecordes
		declare sub salvaRecordes
		declare sub carregaMapa
		declare sub preview
		declare sub destroi							
end type

type cena
	private:
		'opes
		trk_index		as integer		'ndice do circuito [trk(i)]
		orientacao 		as integer		'0 = original | 1 = mirrored | 2 = reversed | 3 = mirrored reversed
		game_mode		as integer		'0 = arcade | 1 = treino (definido em const)
		lod				as integer		'0 = mnimo | 1 = mdio | 2 = mximo
		sfx_on			as integer		'true/false
		
		'buffer de setores
		s				as string
		
		'grficos
		textura (0 to MAX_TEXTURAS, 0 to 99, 0 to 24) as uinteger
		ceu 					as uinteger
		decor (0 to MAX_DECORS)	as imagem3d
		ghost 					as imagem3d
		cc_gfx					as imagem3d
		nuvens					as imagem
		horizonte				as imagem
		neve (0 to 1)			as imagem
		
		'rotinas grficas
		declare sub carregaTextura (i as integer, arquivo as string)
		declare sub graficos ()
		declare sub texturizaPista (x1 as integer, x2 as integer, i as integer, y as double, setor as string)
		declare sub texturizaGrama (x1 as integer, sentido as integer, i as integer, y as double, tam as integer)
		declare sub efeitoNeve (i as integer)
		
		'rotinas de som
		declare sub iniciaSons ()
		declare sub paraSons ()
		declare sub sons ()
		
		'privates do jogo
		declare function getGhostCoord () as double
		declare function inputGeral () as integer
		declare sub pausa ()
		
	public:
		'interface
		const as integer GM_ARCADE = 0
		const as integer GM_TREINO = 1
		const as integer GM_DEMO = 2
	
		declare function getCircuito () as integer
		declare sub setCircuito (trk_index as integer)
		declare function getOrientacao () as integer
		declare sub setOrientacao (orientacao as integer)
		declare function getGameMode () as integer
		declare sub setGameMode (game_mode as integer)
		declare function getLOD () as integer
		declare sub setLOD (lod as integer)
		declare function getSFXOn () as integer
		declare sub setSFXOn (sfx_on as integer)
		
		declare function getSetor (coord as double) as string
		declare function tamanhoCircuito () as integer
		
		'rotinas de jogo
		declare sub cria ()
		declare sub gameLoop ()
		declare sub destroi ()
end type

type listamenu
	private:
		item (0 to MAX_MENU_ITEMS) as string
		titulo		as string
		max_itens	as integer
		default		as integer
		
	public:
		declare function getItem (i as integer) as string
		declare function getTitulo () as string
		declare function getMaxItens () as integer
		declare function getDefault () as integer
		declare sub setDefault (i as integer)
		
		declare sub nova (titulo as string)	
		declare sub insereItem (texto as string)	
end type

type interface
	private:
		lista		as listamenu
		fundo		as imagem
		sombra		as imagem
		musica_on	as integer
		
		declare function menuInput () as integer
		declare sub fadeIn ()
		declare sub fadeOut ()
		declare sub chamaJogo ()
		
	public:
		bgmusic as musica
		declare function getMusicaOn () as integer
		declare sub setMusicaOn (musica_on as integer)
		
		declare sub intro ()
		declare sub ajuda ()
		declare sub menu ()
end type

'declara subs
'* Main
declare sub inicio ()
declare sub fim ()

'declara variveis
dim shared as imagem tela, icone
dim shared pal as palete
dim shared fnt as fonte
dim shared tmp as tempos
dim shared fps as framerate
dim shared evt as eventos
dim shared kev as controle
dim shared mdl (0 to MAX_CARROS) as modelo
dim shared car as carro
dim shared cc as listacc
dim shared nit as nitros
dim shared trk (0 to MAX_CIRCUITOS) as circuito
dim shared scn as cena
dim shared gui as interface

dim shared as som sfx_motor, sfx_derrapagem, sfx_grama, sfx_colisao, sfx_boost, sfx_pickup, sfx_checkpoint, sfx_ultrapassagem
dim shared as som sfx_menu_tic, sfx_menu_bip, sfx_menu_swoosh
dim shared sfx_voc(0 to 3) as som

'comea
inicio
gui.intro
gui.menu

'=======================================================================
'* Main

sub inicio
	dim as integer i, fullscreen, lod, sfx_on, musica_on, max_fps, steer_aid
	dim res as tupla

	'carrega opes
	open "configs" for input as #1
		if eof(1) then
			res.x = 640
			res.y = 480
			fullscreen = false
			lod = 2
			sfx_on = true
			musica_on = true
			max_fps = 60
			steer_aid = true
		else
			input #1, res.x, res.y, fullscreen, lod, sfx_on, musica_on, max_fps, steer_aid
		end if
	close

	'inicializa bibliotecas
	SDL_Init SDL_INIT_VIDEO
	alutInit 0, 0
	randomize timer
		
	'inicia tela principal
	icone.carrega "gfx/icone32.bmp"
	tela.setRes res.x, res.y, fullscreen
	tela.setIcone icone
	
	'carrega grficos
	fnt.carrega "gfx/fonte.bmp", "gfx/numeral.bmp"
	pal.carrega "gfx/car/palete.bmp"
	
	'carrega sons
	sfx_motor.carrega			"sfx/motor.wav"
	sfx_motor.setLoop			true
	sfx_derrapagem.carrega		"sfx/derrapagem.wav"
	sfx_derrapagem.setLoop		true
	sfx_grama.carrega			"sfx/grama.wav"
	sfx_grama.setLoop			true
	sfx_colisao.carrega			"sfx/colisao.wav"
	sfx_boost.carrega			"sfx/boost.wav"
	sfx_pickup.carrega			"sfx/pickup.wav"
	sfx_checkpoint.carrega		"sfx/checkpoint.wav"
	sfx_ultrapassagem.carrega	"sfx/ultrapassagem.wav"
	sfx_menu_tic.carrega		"sfx/menu_tic.wav"
	sfx_menu_bip.carrega		"sfx/menu_bip.wav"
	sfx_menu_swoosh.carrega		"sfx/menu_swoosh.wav"
	sfx_voc(3).carrega			"sfx/voc_3.wav"
	sfx_voc(2).carrega			"sfx/voc_2.wav"
	sfx_voc(1).carrega			"sfx/voc_1.wav"
	sfx_voc(0).carrega			"sfx/voc_go.wav"
	sfx_voc(0).setVolume		1
	
	'declara carros
	for i = 0 to MAX_CARROS
		mdl(i).cria(i)
	next
	
	'declara circuitos
	for i = 0 to MAX_CIRCUITOS
		trk(i).cria(i)
	next
	
	'define defaults
	car.setModelo mdl(0).FERRARI
	car.setPalete 2
	car.setAutoGear true
	car.setSteerAid steer_aid
	scn.setCircuito trk(0).SUBURBAN
	scn.setLOD lod
	scn.setSFXOn sfx_on
	gui.setMusicaOn musica_on
	fps.setMaxFPS max_fps
end sub

sub fim
	dim as integer i, j
	dim res as tupla

	'salva opes
	res = tela.getDimensoes
	open "configs" for output as #1
		print #1, res.x, res.y, tela.getFullscreen, scn.getLOD, scn.getSFXOn, gui.getMusicaOn, fps.getMaxFPS, car.getSteerAid
	close

	'desaloca imagens e sons
	tela.destroi
	icone.destroi
	fnt.destroi
	pal.destroi
	
	for i = 0 to MAX_CIRCUITOS
		trk(i).destroi
	next
	
	sfx_motor.destroi
	sfx_derrapagem.destroi
	sfx_grama.destroi
	sfx_colisao.destroi
	sfx_boost.destroi
	sfx_pickup.destroi
	sfx_ultrapassagem.destroi
	sfx_menu_tic.destroi
	sfx_menu_bip.destroi
	sfx_menu_swoosh.destroi
	for i = 0 to 3
		sfx_voc(i).destroi
	next
	
	'fecha bibliotecas
	SDL_Quit
	alutExit
	
	end
end sub

'=======================================================================
'* Objetos

function imagem.getSurface () as SDL_Surface ptr
	return surface
end function

function imagem.getDimensoes () as tupla
	dim dimensoes as tupla
	
	dimensoes.x = surface->w
	dimensoes.y = surface->h
	
	return dimensoes
end function

function imagem.getFullscreen () as byte
	return fullscreen
end function

function imagem.getPitch () as integer
	return surface->pitch
end function

function imagem.getBPP () as integer
	return surface->format->BytesPerPixel
end function

function imagem.getPixel (x as integer, y as integer) as uinteger
	dim pixel as uinteger ptr
	
	pixel = surface->pixels + (y * getPitch) + (x * getBPP)
	return *pixel and &h00FFFFFF
end function

sub imagem.pintaPixel (offset as integer, cor as uinteger)
	dim pixel as uinteger ptr
	
	pixel = surface->pixels + offset
	*pixel = cor
end sub

sub imagem.pintaPixel (x as integer, y as integer, cor as uinteger)
	pintaPixel (y * getPitch) + (x * getBPP), cor
end sub

sub imagem.pintaLinha (x1 as integer, y1 as integer, x2 as integer, y2 as integer, cor as uinteger)
	dim r as SDL_Rect
	r.x = x1
	r.y = y1
	r.w = x2 - x1 + 1
	r.h = y2 - y1 + 1

	SDL_FillRect surface, @r, cor
end sub

sub imagem.pintaSprite (sprite as imagem, x as integer, y as integer)
	dim r as SDL_Rect
	r.x = x
	r.y = y

	SDL_BlitSurface sprite.getSurface, NULL, surface, @r
end sub

sub imagem.pintaSprite (sprite as imagem, x as integer, y as integer, transparencia as ubyte)
	SDL_SetAlpha sprite.getSurface, SDL_SRCALPHA, transparencia
	
	pintaSprite sprite, x, y
end sub

sub imagem.copiaSprite (sprite as imagem, x1 as integer, y1 as integer, x2 as integer, y2 as integer)
	dim as uinteger color_key = &hff00ff
	
	dim r as SDL_Rect
	r.x = x1
	r.y = y1
	r.w = x2 - x1 + 1
	r.h = y2 - y1 + 1

	'tem que desabilitar a color key para que ela seja copiada
	SDL_SetColorKey sprite.getSurface, SDL_SRCCOLORKEY, NULL
	
	'copia
	SDL_BlitSurface sprite.getSurface, @r, surface, NULL
	
	'retorna a color key do original
	SDL_SetColorKey sprite.getSurface, SDL_SRCCOLORKEY, color_key
end sub

sub imagem.aplicaPalete (pal_origem as integer, pal_destino as integer)
	dim as integer i, j, x, y, cor
	dim pixcor as uinteger
		
	'l dimenses do buffer
	dim dimensoes as tupla
	dimensoes = getDimensoes
	
	'substitui
	for i = 0 to (dimensoes.x - 1)
		for j = 0 to (dimensoes.y - 1)
			pixcor = getPixel(i, j)
			
			for cor = 0 to MAX_PAL_COLORS
				if pal.match(pal_origem, cor, pixcor) then pintaLinha i, j, i, j, pal.getCor(pal_destino, cor)
			next
		next
	next
end sub

function imagem.efeitoCor (cor as uinteger, efeito as integer, amount as ubyte) as uinteger
	'economiza cpu
	if efeito = FX_NULL then return cor
	
	'extrai as primrias
	dim as integer r, g, b
	r = (cor and &h00FF0000) / &hFFFF
	g = (cor and &h0000FF00) / &hFF
	b = cor and &h000000FF
	
	'corrige erro chato de arredondamento
	if g > 255 then g = 255
					
	'aplica efeito
	select case efeito
		case FX_PRETO_E_BRANCO
			dim as single bw
			
			bw = ((11 * r) + (16 * g) + (5 * b)) / 32
			if bw > 255 then bw = 255
					
			return rgb(bw, bw, bw)
		
		case FX_ESCURECE
			r = r - amount
			if r < 0 then r = 0
			
			g = g - amount
			if g < 0 then g = 0
			
			b = b - amount
			if b < 0 then b = 0
			
			return rgb(r, g, b)
		
		case FX_NEVOA
			dim as single mix1, mix2
			mix1 = amount / 255
			mix2 = 1 - mix1
			
			r = (BRILHO_NEVOA * mix1) + (r * mix2)
			g = (BRILHO_NEVOA * mix1) + (g * mix2)
			b = (BRILHO_NEVOA * mix1) + (b * mix2)

			return rgb(r, g, b)
	end select
end function

function imagem.efeitoCor (cor as uinteger, efeito as integer) as uinteger
	return efeitoCor(cor, efeito, 0)
end function

sub imagem.efeitoSprite (efeito as integer, fator as single)
	'fator 0: mais escuro | 1: mais claro (original)
	dim as integer i, j, x, y, r, g, b, brilho, cor
	dim as uinteger pixcor, color_key
	dim dimensoes as tupla
	
	color_key = pal.getCor(0, MAX_PAL_COLORS) 'transparncia
	brilho = 96 * (1 - fator) 'a ser subtrado
	brilho = brilho ^ 1.2
	
	'l dimenses do buffer
	dimensoes = getDimensoes
	
	'aplica efeito (escurece/nvoa)
	for i = 0 to (dimensoes.x - 1)
		for j = 0 to (dimensoes.y - 1)
			'l cor do pixel
			pixcor = getPixel(i, j)
		
			'checa se no  parte da palete de farol (deixa aceso)
			for cor = 8 to 18
				if pal.match(0, cor, pixcor) then pixcor = color_key
			next
			
			'muda a cor dos retrovisores no circuito da nvoa
			for cor = 28 to 29
				if pal.match(0, cor, pixcor) and efeito = FX_NEVOA then
					'repinta
					pintaLinha i, j, i, j, efeitoCor(pixcor, FX_PRETO_E_BRANCO, 1)
					
					'atualiza
					pixcor = getPixel(i, j)
				end if
			next
		
			'recolorizao geral
			if pixcor <> color_key then
				'modifica
				pixcor = efeitoCor(pixcor, efeito, brilho)
				
				'repinta
				pintaLinha i, j, i, j, pixcor
			end if
		next
	next
end sub

sub imagem.efeitoTela (efeito as integer, amount as ubyte)
	dim as integer x, y, xp, yp
	dim pixel as uinteger ptr
	dim pixcor as uinteger
	
	dim buffer as any ptr
	dim as integer pitch, bpp
	buffer = surface->pixels
	pitch = getPitch
	bpp = getBPP
	
	'faz acesso direto a vdeo
	for x = 0 to 319
		xp = x * bpp
	
		for y = 0 to 239
			yp = y * pitch
		
			pixel = buffer + xp + yp
			pixcor = *pixel			
			*pixel = efeitoCor(pixcor, efeito, amount)
		next
	next
end sub

sub imagem.setIcone (sprite as imagem)
	SDL_WM_SetIcon sprite.getSurface, NULL
end sub

sub imagem.setRes (w as integer, h as integer, fullscreen as integer)
	dim flags as integer
	
	'muda resoluo
	if fullscreen then
		flags = SDL_FULLSCREEN or SDL_SWSURFACE or SDL_DOUBLEBUF
	else
		flags = SDL_SWSURFACE or SDL_DOUBLEBUF
	end if
	
	surface = SDL_SetVideoMode(w, h, TELA_BPP, flags)
	this.fullscreen = fullscreen
	
	'opes da tela
	SDL_WM_SetCaption "Pe na Tabua", "Pe na Tabua"
	SDL_ShowCursor SDL_DISABLE
end sub

sub imagem.pixelDoubling
	dim as integer x, y, xp, xp2, yp, yp2, offset
	dim pixel as uinteger ptr
	dim pixcor as uinteger
	
	dim buffer as any ptr
	dim as integer pitch, bpp
	buffer = surface->pixels
	pitch = getPitch
	bpp = getBPP
	
	'faz pixel doubling
	for x = 319 to 0 step -1
		xp = x * bpp
		xp2 = (x + x) * bpp
		
		for y = 239 to 0 step -1
			yp = y * pitch
			yp2 = (y + y) * pitch
				
			'guarda informao do pixel
			'{
				pixel = buffer + yp + xp
				pixcor = *pixel
			'}
						
			'aplica scale2x
			'{
				offset = xp2 + yp2
				
				pixel = buffer + offset
				*pixel = pixcor
			
				pixel = buffer + offset + pitch
				*pixel = pixcor
			
				offset = offset + bpp
			
				pixel = buffer + offset
				*pixel = pixcor
			
				pixel = buffer + offset + pitch
				*pixel = pixcor
			'}
		next
	next
end sub

sub imagem.atualiza
	dim res as tupla
	res = getDimensoes
	
	if res.x > 320 and res.y > 240 then
		trava
		pixelDoubling
		destrava
	end if

	SDL_Flip surface
end sub

sub imagem.trava
	SDL_LockSurface surface
end sub

sub imagem.destrava 
	SDL_UnlockSurface surface
end sub

sub imagem.cria (w as integer, h as integer)
	dim as uinteger color_key = &hff00ff

	surface = SDL_CreateRGBSurface(SDL_SWSURFACE, w, h, TELA_BPP, 0, 0, 0, 0)
	
	SDL_SetColorKey surface, SDL_SRCCOLORKEY, color_key
end sub

sub imagem.carrega (arquivo as string)
	dim as uinteger color_key = &hff00ff

	surface = IMG_Load(arquivo)
	
	if surface = NULL then
		print "Imagem nao encontrada: "; arquivo
		fim
	end if
	
	SDL_SetColorKey surface, SDL_SRCCOLORKEY, color_key
end sub

sub imagem.destroi
	SDL_FreeSurface surface
end sub

'-----------------------------------------------------------------------

function palete.getNome (i as integer) as string
	return nome(i)
end function

function palete.getCor (i as integer, j as integer) as uinteger
	return cor(i, j)
end function

function palete.match (i as integer, j as integer, cor as uinteger) as integer
	'problemtico! SDL usa mil formatos de pixel diferentes para as surfaces
	'a palete pode quebrar se tela_bpp for menor que 32 ou se o arquivo palete.bmp no for rgb
	return (this.cor(i, j) and &h00FFFFFF) = (cor and &h00FFFFFF)
end function

sub palete.carrega (arquivo as string)
	dim as integer i, j

	'gera paletes
	dim palete_buffer as imagem
	palete_buffer.cria MAX_PALETES + 1, MAX_PAL_COLORS + 1
	palete_buffer.carrega arquivo
	
	for i = 0 to MAX_PALETES
		'gera paletes
		for j = 0 to MAX_PAL_COLORS
			cor(i, j) = palete_buffer.getPixel(i, j)
		next
		
		'gera previews (hardcoded)
		preview(i).cria (8 * 8), 8
		
		for j = 0 to 7
			preview(i).pintaLinha j * 8, 0, (j * 8) + 7, 7, cor(i, 20 + j)
		next
		
		'gera nomes (hardcoded)
		select case i
			case 0: nome(i) = "amarelo"
			case 1: nome(i) = "laranja"
			case 2: nome(i) = "vermelho"
			case 3: nome(i) = "roxo"
			case 4: nome(i) = "azul"
			case 5: nome(i) = "ciano"
			case 6: nome(i) = "verde"
			case 7: nome(i) = "prata"
		end select
	next
	
	palete_buffer.destroi
end sub

sub palete.pintaPreview (i as integer, x as integer, y as integer)
	tela.pintaSprite preview(i), x, y
end sub

sub palete.destroi
	dim i as integer
	
	for i = 0 to MAX_PALETES
		preview(i).destroi
	next
end sub

'-----------------------------------------------------------------------
sub fonte.pinta (x as integer, y as integer, texto as string, cor as integer)
	dim as integer i, char
	
	'converte texto para minsculas
	texto = lcase(texto)
	
	'centralizado?
	if x = -1 then x = 160 - ((len(texto) * 6) / 2)
	
	for i = 1 to len(texto)
		'define caractere		
		select case mid(texto, i, 1)
			case " ": char = -1
							
			'converte de ASCII para custom
			case "a" to "z": char = asc(mid(texto, i, 1)) - asc("a")
			case "0" to "9": char = asc(mid(texto, i, 1)) - asc("0") + 26
			
			'casos especiais / internacionalizao
			case "", "": char = 36
			case "", "": char = 37
			case "", "": char = 38
			case "", "": char = 39
			case "", "": char = 40
			case "", "", "", "": char = 41
			case "", "": char = 42
			case "", "", "", "": char = 43
			case "", "": char = 44
			case "!": char = 45
			case "?": char = 46
			case ".": char = 47
			case ",": char = 48
			case ":": char = 49
			case "/": char = 50
			case "(": char = 51
			case ")": char = 52
			case "*": char = 53 'smbolo de vezes
			case "-": char = 54
			case "+": char = 55
			case "<": char = 56
			case ">": char = 57
			case "$": char = 58 'smbolo de copyright
			case "@": char = 59
			case "_": char = 60
			case "&": char = 61	'reticncias
			case "|": char = 62 'cone nitro (0)
			case "{": char = 63 'AU
			case "}": char = 64 'TO
			case "[": char = 65 'm minsculo
			case "]": char = 66 'h minsculo
			case else: char = 46
		end select
		
		'pinta caractere
		if char > -1 then tela.pintaSprite alfanumerico(cor, char), x + ((i - 1) * 6), y
	next	
end sub

sub fonte.pinta (x as integer, y as integer, texto as string, cor as integer, sombreado as integer)
	dim as integer i, j
	
	'centralizado?
	if x = -1 then x = 160 - ((len(texto) * 6) / 2)
	
	'sombra
	if sombreado = true then	
		for i = -1 to 1
			for j = -1 to 1
				pinta x + i, y + j, texto, 1
			next
		next
	end if
	
	'claro
	pinta x, y, texto, cor
end sub

sub fonte.mensagem (texto as string, cor as integer)
	pinta -1, 120, texto, cor, true
end sub

sub fonte.pintaNumero (x as integer, y as integer, texto as string)
	dim as integer i, char
		
	for i = 1 to len(texto)
		select case val(mid(texto, i, 1))
			case 0 to 9: char = val(mid(texto, i, 1))
			case else: char = 0
		end select
		 
		tela.pintaSprite numeral(char), x + ((i - 1) * 12), y
	next
end sub

sub fonte.carrega (arquivo1 as string, arquivo2 as string)
	dim as integer i, j

	dim fonte_buffer as imagem
	
	'letras pequenas
	fonte_buffer.carrega arquivo1
	for i = 0 to MAX_FONT_CHARS
		for j = 0 to MAX_FONT_COLORS
			alfanumerico(j, i).cria 6, 8
			alfanumerico(j, i).copiaSprite fonte_buffer, i * 6, j * 8, (i * 6) + 5, (j * 8) + 7
		next
	next
	
	'nmeros grandes
	fonte_buffer.carrega arquivo2
	for i = 0 to 9
		numeral(i).cria 12, 14
		numeral(i).copiaSprite fonte_buffer, i * 12, 0, (i * 12) + 11, 13
	next
		
	fonte_buffer.destroi
end sub

sub fonte.destroi
	dim as integer i, j
			
	for i = 0 to MAX_FONT_COLORS
		for j = 0 to MAX_FONT_CHARS
			alfanumerico(i, j).destroi
		next
	next
	
	for i = 0 to 9
		numeral(i).destroi
	next
end sub

'-----------------------------------------------------------------------
sub som.toca
	'pode tocar?
	if not scn.getSFXOn or scn.getGameMode = scn.GM_DEMO then exit sub

	alSourcePlay source
end sub

sub som.para
	alSourceStop source
end sub

sub som.setLoop (is_true as integer)
	if is_true then
		alSourcei source, AL_LOOPING, AL_TRUE
	else
		alSourcei source, AL_LOOPING, AL_FALSE
	end if
end sub

sub som.setPitch (pitch as ALfloat)
	alSourcef source, AL_PITCH, pitch
end sub

sub som.setPan (pan as ALfloat)
	alSource3f source, AL_POSITION, pan, 0, 0
end sub

sub som.setVolume (volume as ALfloat)
	alSourcef source, AL_GAIN, volume
end sub

sub som.carrega (arquivo as string)
	dim wav_format	as ALenum
	dim wav_size	as ALsizei
	dim wav_freq	as ALsizei
	dim wav_data	as any ptr
	dim wav_loop	as ALboolean
	
	alGenBuffers 1, @buffer
	alGenSources 1, @source
	
	'carrega som no buffer
	alutLoadWAVFile arquivo, @wav_format, @wav_data, @wav_size, @wav_freq, @wav_loop
		alBufferData buffer, wav_format, wav_data, wav_size, wav_freq
	alutUnloadWAV wav_format, wav_data, wav_size, wav_freq
	
	'linka source ao buffer
	alSourcei source, AL_BUFFER, buffer
	
	'valores default do source
	setLoop false
	setPitch 1.0
	setPan 0
	setVolume 0.6
end sub

sub som.destroi ()
	alDeleteBuffers 1, @buffer
	alDeleteSources 1, @source
end sub

'-----------------------------------------------------------------------
function musica.carregaBuffer (buffer_atual as ALuint) as integer
	dim as zstring * BUFFER_VORBIS chunk
	dim as integer bytes = 0
	dim as integer lidos, bitstream
	
	'enche o tamanho de um buffer	
	while bytes < BUFFER_VORBIS
		lidos = ov_read(@ogg_stream, @chunk[bytes], BUFFER_VORBIS - bytes, 0, 2, 1, @bitstream)
	
		if lidos < 0 then
			print "Erro lendo a stream!"
			destroi
			fim
		'fim da stream
		elseif lidos = 0 then
			exit while
		'tem mais
		else
			bytes = bytes + lidos
		end if
	wend
	
	'carregou alguma coisa?
	if bytes = 0 then return false
	
	'liga source ao buffer
	alBufferData buffer_atual, formato, @chunk, bytes, ogg_info->rate
	return true
end function

function musica.atualiza () as integer
	dim buffer_atual as ALuint
	dim processados as integer
	dim as integer ativo = true
	
	alGetSourcei source, AL_BUFFERS_PROCESSED, @processados
	
	'faz troca de buffers
	while processados > 0
		alSourceUnqueueBuffers source, 1, @buffer_atual
		ativo = carregaBuffer(buffer_atual)
		alSourceQueueBuffers source, 1, @buffer_atual

		processados = processados - 1
	wend
	
	if not ativo then pausa
	return ativo
end function

sub musica.pausa
	dim buffer_atual as ALuint
	dim enfileirados as integer
	
	'esvazia os buffers
	alGetSourcei source, AL_BUFFERS_QUEUED, @enfileirados
		
	while enfileirados > 0
		alSourceUnqueueBuffers source, 1, @buffer_atual
	
		enfileirados = enfileirados - 1
	wend
	
	'interrompe o playback
	tocando = false
	alSourceStop source
end sub

function musica.toca () as integer
	dim estado as ALenum
		
	'pode tocar?
	if not gui.getMusicaOn then
		pausa		
		return false

	'j comeou a tocar?
	elseif tocando then
		'checa se o stream no engasgou
		alGetSourcei source, AL_SOURCE_STATE, @estado
		if estado <> AL_PLAYING then alSourcePlay source
	
	'esvaziou todos os buffers
	else
		'h mais para carregar?
		if not carregaBuffer(buffer(0)) then return false
		if not carregaBuffer(buffer(1)) then return false
		
		'enfileira e toca novo
		alSourceQueueBuffers(source, 2, @buffer(0))
		alSourcePlay source
		tocando = true
	end if
	
	'faz streaming
	return atualiza
end function

sub musica.setVolume (volume as ALfloat)
	alSourcef source, AL_GAIN, volume * VOL_MUSICA
end sub

sub musica.carrega (arquivo as string)
	'abre arquivo
	print "Abrindo stream: "; arquivo
	ogg_file = fopen(arquivo, "rb")
	
	if ogg_file = NULL then
		print "Arquivo nao encontrado"
		fim
	end if
	
	'passa para libvorbis
	if ov_open(ogg_file, @ogg_stream, NULL, 0) < 0 then
		print "Erro abrindo arquivo"
		fclose ogg_file
		fim
    end if
    
    'l informaes
    ogg_info = ov_info(@ogg_stream, -1)
    
    if ogg_info->channels = 1 then
		formato = AL_FORMAT_MONO16
	else
		formato = AL_FORMAT_STEREO16
	end if
	
	'gera buffers
	alGenBuffers 2, @buffer(0)
	alGenSources 1, @source
	
	'valores default
	tocando = false
	setVolume 1
	
	'debug
	print "Canais: "; ogg_info->channels
	print "Frequencia: "; ogg_info->rate
end sub

sub musica.destroi
	pausa
	alDeleteBuffers 2, @buffer(0)
	alDeleteSources 1, @source
	ov_clear @ogg_stream
end sub

'-----------------------------------------------------------------------
function tempos.getMS (i as integer) as double
	return ms(i)
end function

function tempos.getVolta () as integer
	return volta_atual
end function

function tempos.getRecordeVoltas () as integer
	return recorde_voltas
end function

function tempos.pisca () as integer
	'padro para eventos que piscam; s funciona enquanto estiver contando tempo
	return (ms(VOLTA) mod 500) < 250
end function

function tempos.formata (t as longint) as string
	dim as string s = ""
	
	'negativo?
	if t < 0 then
		s = "-"
		t = abs(t)
	end if
	
	'minutos
	if t >= 60000 then
		s = s + str(int(t / 60000))
		s = s + ":"
		
		t = t - (60000 * int(t / 60000))
		
		if t < 10000 then s = s + "0" 'completa duas casas
	end if
		
	'segundos
	s = s + str(int(t / 1000))
	s = s + "."

	'milsimos
	t = t - (1000 * int(t / 1000))
	'completa trs casas
	if t < 100 then s = s + "0"
	if t < 10 then s = s + "0"
	
	s = s + str(int(t))
	
	return s	
end function

sub tempos.pintaHud
	dim as string t, t2
	dim as double gap
	dim as integer tempo_pisca = 4000
	
	fnt.pinta 319 - (6 * 6), 07, fps.getFPS + " fps", 1
	
	fnt.pinta 2, 07, "volta&&&& " + str(volta_atual), 0, true
	fnt.pinta 2, 16, "tempo&&&& " + formata(ms(VOLTA)), 0, true
	
	t = "melhor&&& "
	if volta_atual > 1 then
		if not(ms(VOLTA) < tempo_pisca and ms(MELHOR) = ms(ULTIMA)) or pisca then
			t = t + formata(ms(MELHOR))
		end if
	end if
	fnt.pinta 2, 25, t, 0, true
	
	if scn.getGameMode = scn.GM_ARCADE then
		t = "meta&&&&& "
		if ms(VOLTA) >= tempo_pisca then
			gap = (ms(META) * ((car.getCoord - 1) / scn.tamanhoCircuito)) - ms(VOLTA)
			t2 = formata(gap)
			if left(t2, 1) <> "-" then t2 = "+" + t2
						
			if gap > 0 and gap < 300 then
				fnt.mensagem t2, 4
			else
				t = t + t2
			end if
		end if
		fnt.pinta 2, 34, t, 0, true
				
		t = str(int((ms(META) - ms(VOLTA)) / 1000))
		if not(volta_atual > 1 and ms(VOLTA) < tempo_pisca) or pisca then
			fnt.pintaNumero 319 - (12 * len(t)), 18, t
		end if
	end if
	
	if volta_atual > 1 and ms(VOLTA) < tempo_pisca then
		t = formata(ms(ULTIMA))
		
		if ms(RECORDE) = ms(ULTIMA) then
			if pisca then fnt.mensagem "novo recorde: " + t, 2
		else
			fnt.mensagem "volta anterior: " + t, 0
		end if
	end if
end sub

sub tempos.reinicia
	ms(TOTAL) = 0
	ms(VOLTA) = 0
	ms(ULTIMA) = 0
	ms(MELHOR) = 0
	ms(META) = scn.tamanhoCircuito / (trk(scn.getCircuito).getMedia / 25)
	ms(RECORDE) = trk(scn.getCircuito).getRecorde
	
	if scn.getGameMode = scn.GM_ARCADE then
		volta_atual = 0
	else
		volta_atual = 1
	end if
	recorde_voltas = trk(scn.getCircuito).getRecordeVoltas
end sub	

sub tempos.atualiza
	dim as double tempo_quadro
	tempo_quadro = (1000 / 25) * fps.getFator
	
	ms(TOTAL) = ms(TOTAL) + tempo_quadro
	ms(VOLTA) = ms(VOLTA) + tempo_quadro
	
	'game over
	if scn.getGameMode = scn.GM_ARCADE and ms(VOLTA) > ms(META) then
		evt.setStatus evt.GAME_OVER, true
		evt.setStatus evt.AUTO_PILOT, true
	end if
	
	'completa volta
	if evt.getStatus(evt.COMPLETA_VOLTA) then
		'reespalha nitros
		nit.spawn false
		
		'contagem de tempo
		ms(ULTIMA) = ms(VOLTA)
		
		if volta_atual = 1 then
			ms(MELHOR) = ms(ULTIMA)
		else
			if ms(ULTIMA) < ms(MELHOR) then ms(MELHOR) = ms(ULTIMA)
		end if
		if volta_atual > 0 and ms(MELHOR) < ms(RECORDE) then ms(RECORDE) = ms(MELHOR)
		
		ms(VOLTA) = 0
		
		'atualizao da meta
		if volta_atual > 0 then ms(META) = ms(META) * trk(scn.getCircuito).getDificuldade
		
		'contagem de voltas
		if not evt.getStatus(evt.GAME_OVER) then volta_atual = volta_atual + 1
		
		if scn.getGameMode = scn.GM_ARCADE and (volta_atual - 1) > recorde_voltas then
			recorde_voltas = volta_atual - 1
		end if
	end if
end sub

'-----------------------------------------------------------------------
function framerate.getFator () as double
	return fator
end function

function framerate.getFPS () as string
	return str(int(fps))
end function

function framerate.getMaxFPS () as integer
	return max_fps
end function

sub framerate.setMaxFPS (max_fps as integer)
	this.max_fps = max_fps
end sub

sub framerate.reinicia ()
	fator = 1
	old_timer = -1
end sub	

sub framerate.atualiza ()
	'calcula fator
	if old_timer = -1 then
		timer_dif = 1 / 25
	else
		timer_dif = timer - old_timer
	end if
	old_timer = timer 	'para o prximo ciclo
	
	fps = 1 / timer_dif
	fator = 25 / fps
end sub	

sub framerate.preciseSleep ()
	dim as double intervalo, cron	'em segundos
	
	'calcula intervalo necessrio
	intervalo = (1 / max_fps) - (timer - old_timer)
	cron = timer
	
	do
		sleep 0, 1 'o negcio aqui  liberar tempo para o sistema e pegar de volta o mais rpido possvel
	loop until (timer - cron) > intervalo
end sub

'-----------------------------------------------------------------------
function eventos.getStatus (i as integer) as integer
	return status(i)
end function

sub eventos.setStatus (i as integer, status as integer)
	this.status(i) = status
end sub
		
sub eventos.reinicia()
	dim as integer i
	
	for i = 0 to MAX_EVENTOS
		status(i) = false
	next
end sub

'-----------------------------------------------------------------------
function controle.confereTecla (i as integer, estado as integer) as integer
	if (estado = DOWN) or (estado = PRESSED and last_tecla(i) = false) then return tecla(i)
end function

sub controle.atualiza
	dim as integer i
	
	'copia estado anterior
	for i = 0 to MAX_TECLAS
		last_tecla(i) = tecla(i)
	next
	
	'atualiza key state
	SDL_PumpEvents
	key_state = SDL_GetKeyState(NULL)
	
	'mapeia sdl para vetor interno
	tecla(K_UP)			= key_state[SDLK_UP]
	tecla(K_DOWN)		= key_state[SDLK_DOWN] 
	tecla(K_LEFT)		= key_state[SDLK_LEFT]
	tecla(K_RIGHT)		= key_state[SDLK_RIGHT]
	tecla(K_MARCHA)		= key_state[SDLK_Z]
	tecla(K_NITRO)		= key_state[SDLK_X]
	tecla(K_ESCOLHE)	= key_state[SDLK_RETURN]
	tecla(K_RETORNA)	= key_state[SDLK_ESCAPE]
	tecla(K_PAUSA)		= key_state[SDLK_P] or key_state[SDLK_PAUSE]
end sub

sub controle.esperaTecla
	do
		atualiza
		gui.bgmusic.toca 'continua stream do menu
		sleep 5, 1
	loop until confereTecla(K_ESCOLHE, PRESSED) or confereTecla(K_RETORNA, PRESSED)
end sub

'-----------------------------------------------------------------------
function listamenu.getItem (i as integer) as string
	if i > max_itens then
		return "out of range!"
	else
		return item(i)
	end if
end function

function listamenu.getTitulo () as string
	return titulo
end function

function listamenu.getMaxItens () as integer
	return max_itens
end function

function listamenu.getDefault () as integer
	return default
end function

sub listamenu.setDefault (i as integer)
	if i <= max_itens then default = i
end sub

sub listamenu.nova (titulo as string)
	max_itens = -1
	this.titulo = titulo
	setDefault 0
end sub
		
sub listamenu.insereItem (texto as string)
	if max_itens < MAX_MENU_ITEMS then
		max_itens = max_itens + 1
		
		item(max_itens) = texto
	end if	
end sub

'-----------------------------------------------------------------------
function pilhasprites.naoVazia () as integer
	return ponteiro >= 0
end function

sub pilhasprites.nova
	ponteiro = -1
end sub

sub pilhasprites.push (i as integer, x as integer, y as integer, tam as integer, tem_topo as integer)
	if ponteiro < MAX_SPRITES then
		ponteiro = ponteiro + 1
		
		item(ponteiro).i = i
		item(ponteiro).x = x
		item(ponteiro).y = y
		item(ponteiro).tam = tam
		item(ponteiro).tem_topo = tem_topo
	end if	
end sub

sub pilhasprites.push (i as integer, x as integer, y as integer, tam as integer)
	push i, x, y, tam, false
end sub

function pilhasprites.pop () as sprite3d
	dim spr as sprite3d
	
	if ponteiro >= 0 then
		spr.i = item(ponteiro).i
		spr.x = item(ponteiro).x
		spr.y = item(ponteiro).y
		spr.tam = item(ponteiro).tam
		spr.tem_topo = item(ponteiro).tem_topo
		
		ponteiro = ponteiro - 1
	end if
	
	return spr
end function

'-----------------------------------------------------------------------
sub imagem3d.pintaDecor (spr as sprite3d)
	dim as integer off_x, off_y, i
	
	select case spr.tam
		case is < 6
			off_y = 6
			i = 9
		case 6 to 8
			off_y = 8
			i = 8
		case 8 to 10
			off_y = 10
			i = 7
		case 10 to 12
			off_y = 12
			i = 6
		case 12 to 16
			off_y = 16
			i = 5
		case 16 to 24
			off_y = 24
			i = 4
		case 24 to 32
			off_y = 32
			i = 3
		case 32 to 48
			off_y = 48
			i = 2
		case 48 to 64
			off_y = 64
			i = 1
		case is > 64
			off_y = 96
			i = 0
	end select
	
	off_x = off_y / 4
		
	tela.pintaSprite sprite(i), spr.x - off_x, spr.y - off_y
	
	'topo do tnel (hardcoded)
	if spr.tem_topo and spr.i = 3 and off_y > 6 then
		dim as integer j
		
		for j = spr.x - off_x to 0 - (off_x * 3) step off_x * -2 
			tela.pintaSprite sprite(i), j, spr.y - (2 * off_y)
		next
		
		for j = spr.x + off_x to 319 step off_x * 2
			tela.pintaSprite sprite(i), j, spr.y - (2 * off_y)
		next
	end if
end sub

sub imagem3d.pintaCC (spr as sprite3d, transparencia as ubyte)
	dim as integer off_x, off_y, i
	
	select case spr.tam
		case is < 4
			off_y = 3
			i = 9
		case 4 to 6
			off_y = 6
			i = 8
		case 6 to 9
			off_y = 9
			i = 7
		case 9 to 12
			off_y = 12
			i = 6
		case 12 to 16
			off_y = 16
			i = 5
		case 16 to 21
			off_y = 21
			i = 4
		case 21 to 27
			off_y = 27
			i = 3
		case 27 to 36
			off_y = 36
			i = 2
		case 36 to 48
			off_y = 48
			i = 1
		case is > 48
			off_y = 60
			i = 0
	end select
	
	off_x = off_y * 5 / 6
	if i = 5 then off_x = 14 'aproximao
	
	tela.pintaSprite sprite(i), spr.x - off_x, spr.y - off_y, transparencia
end sub

sub imagem3d.pintaCC (spr as sprite3d)
	pintaCC spr, 255
end sub

sub imagem3d.carregaDecor (arquivo as string)
	dim as integer m, x, y
	dim as single r, s
	
	sprite(3).carrega arquivo + "_32.bmp"
	sprite(4).carrega arquivo + "_24.bmp"
	sprite(5).carrega arquivo + "_16.bmp"
	sprite(6).carrega arquivo + "_12.bmp"
	sprite(7).carrega arquivo + "_10.bmp"
	sprite(8).carrega arquivo + "_08.bmp"
	sprite(9).carrega arquivo + "_06.bmp"
	
	m = 0
	
	while m < 3
		if m = 0 then
			y = 96
		elseif m = 1 then
			y = 64
		elseif m = 2 then
			y = 48
		end if
			
		x = y / 2
		
		'cria imagem
		sprite(m).cria x, y
		
		'faz scaling
		for r = 0 to (x - 1)
			for s = 0 to (y - 1)
				sprite(m).pintaLinha r, s, r, s, sprite(3).getPixel(int(r * (16 / x)), int(s * (32 / y)))
			next
		next
		
		m = m + 1
	wend
	
	'escurece
	if trk(scn.getCircuito).noite then
		for m = 1 to 9
			sprite(m).efeitoSprite sprite(m).FX_ESCURECE, 0.9 - (m * 0.1)
		next
	end if
	
	'nvoa
	if trk(scn.getCircuito).nevoa then
		for m = 1 to 9
			sprite(m).efeitoSprite sprite(m).FX_NEVOA, 0.9 - (m * 0.1)
		next
	end if
end sub

sub imagem3d.carregaCC (mdl_index as integer, palete as integer)
	dim as integer m, n, x, y
	dim as single r, s
	
	dim carro_buffer as carro
	carro_buffer.setModelo mdl_index
	carro_buffer.setPalete palete
	carro_buffer.carrega true 'no aplicar efeitos!
		
	sprite(0).cria 100, 60
	sprite(0).copiaSprite carro_buffer.getSprite, 0, 0, 99, 59
	sprite(0).aplicaPalete 0, palete 'assume que a chamada  feita antes de mudar a palete de car.sprite 
	
	carro_buffer.destroi
	
	for m = 1 to 9
		if m = 1 then
			y = 48
		elseif m = 2 then
			y = 36
		elseif m = 3 then
			y = 27
		elseif m = 4 then
			y = 21
		elseif m = 5 then
			y = 16
		elseif m = 6 then
			y = 12
		elseif m = 7 then
			y = 9
		elseif m = 8 then
			y = 6
		else
			y = 3
		end if
			
		x = y * 5 / 3
		if m = 5 then x = 28 'aproximao
		
		'cria imagem
		sprite(m).cria x, y
			
		'faz scaling
		for r = 0 to (x - 1)
			for s = 0 to (y - 1)
				sprite(m).pintaLinha r, s, r, s, sprite(0).getPixel(int(r * (100 / x)), int(s * (60 / y)))
			next
		next
	next
	
	'escurece
	if trk(scn.getCircuito).noite then
		for m = 1 to 9
			sprite(m).efeitoSprite sprite(m).FX_ESCURECE, 0.9 - (m * 0.1)
		next
	end if
	
	'nevoa
	if trk(scn.getCircuito).nevoa then
		for m = 1 to 9
			sprite(m).efeitoSprite sprite(m).FX_NEVOA, 0.9 - (m * 0.1)
		next
	end if
end sub

sub imagem3d.destroi
	dim i as integer
	
	for i = 0 to 9
		sprite(i).destroi
	next
end sub

'-----------------------------------------------------------------------
function modelo.getNome () as string
	return nome
end function

function modelo.getFatorVel () as double
	return fator_vel
end function

function modelo.getFatorGrip () as double
	return fator_grip
end function

function modelo.getPaleteDefault () as integer
	return palete_default
end function

function modelo.getLuzFreio () as tupla
	return luz_freio
end function

function modelo.getEscapamento () as tupla
	return escapamento
end function

function modelo.getOffset () as integer
	return offset
end function

sub modelo.cria (i as integer)
	select case i
		case FERRARI:
			nome = "scirocco spider"
			fator_vel = 1
			fator_grip = 1
			palete_default = 2
			luz_freio.x = 12
			luz_freio.y = 35
			escapamento.x = 13
			escapamento.y = 52
			offset = 3
		
		case FORD:
			nome = "speedster gt"
			fator_vel = 1
			fator_grip = 1
			palete_default = 4
			luz_freio.x = 18
			luz_freio.y = 38
			escapamento.x = 46
			escapamento.y = 50
			offset = 4
		
		case PORSCHE:
			nome = "diamond coup"
			fator_vel = 0.98
			fator_grip = 1.1
			palete_default = 7
			luz_freio.x = 18
			luz_freio.y = 33
			escapamento.x = 23
			escapamento.y = 53
			offset = 3
		
		case GOLF:
			nome = "handler ss"
			fator_vel = 0.98
			fator_grip = 1.1
			palete_default = 5
			luz_freio.x = 16
			luz_freio.y = 26
			escapamento.x = 34
			escapamento.y = 53
			offset = 3
	end select
end sub

'-----------------------------------------------------------------------
function carro.getCoord () as double
	return coord
end function

function carro.getLastCoord () as double
	return last_coord
end function

function carro.getVel () as double
	return vel
end function

function carro.getX () as double
	return x
end function

function carro.getRPM () as double
	return rpm
end function

function carro.getAng () as double
	return ang
end function

function carro.getSprite () as imagem
	return sprite(0)
end function

function carro.getModelo () as integer
	return mdl_index
end function

sub carro.setModelo (mdl_index as integer)
	this.mdl_index = mdl_index
end sub

function carro.getPalete () as integer
	return palete
end function

sub carro.setPalete (palete as integer)
	this.palete = palete
end sub

function carro.getAutoGear () as integer
	return auto_gear
end function

sub carro.setAutoGear (auto_gear as integer)
	this.auto_gear = auto_gear
end sub

function carro.getSteerAid () as integer
	return steer_aid
end function

sub carro.setSteerAid (steer_aid as integer)
	this.steer_aid = steer_aid
end sub

sub carro.reinicia ()
	if scn.getGameMode = scn.GM_ARCADE then
		coord = scn.tamanhoCircuito - 10.5
		vel = 0.06
		x = 0
	elseif scn.getGameMode = scn.GM_DEMO then
		coord = 1
		vel = 0
		x = 0
	else
		coord = 1
		vel = 0
		x = 0.4
	end if
	last_coord = coord
	acc = 0
	accx = 0
	marcha = 0
	rpm = 0
	ang = 0
	nitros = 0
	fumaca_fade = 0
	tempo_nitro = 0
	
	inercia(1) = 0.9943
	acc_max(1) = 0.0009 * mdl(mdl_index).getFatorVel
	inercia(0) = 0.9829
	acc_max(0) = 0.0019 * mdl(mdl_index).getFatorVel

	vel_limiar = 0.095 * mdl(mdl_index).getFatorGrip
	x_step = 0.03 * mdl(mdl_index).getFatorGrip
	x_center = x_step * 2
	x_lock = 0.7
end sub

sub carro.controles
	dim as double x_step_reduce, x_center_reduce
	dim setor as string
	
	'piloto automtico?
	if evt.getStatus(evt.AUTO_PILOT) then
		setor = scn.getSetor(coord)
		
		'pedais
		if (setor = "c" or setor = "d") and vel < 0.03 then
			acc = acc_max(0) * 1
		elseif (setor <> "c" and setor <> "d") and vel < 0.06 then
			acc = acc_max(0) * 1
		else
			acc = 0
		end if
		evt.setStatus evt.FREIO, false
		
		'cmbio
		if (setor = "c" or setor = "d") or vel < 0.01 then marcha = 0
		
		'volante
		if x < -0.02 then
			accx = accx + (x_step * fps.getFator)
			if accx > (limiar * 0.6) then accx = (limiar * 0.6)
		elseif x > 0.02 then
			accx = accx - (x_step * fps.getFator)
			if accx < (limiar * -0.6) then accx = (limiar * -0.6)
		else
			if accx > (x_center * fps.getFator) then
				accx = accx - (x_center * fps.getFator)
			elseif accx < (x_center * fps.getFator * -1) then
				accx = accx + (x_center * fps.getFator)
			end if
		end if
		
		'sequestra controles
		exit sub
	end if
	
	'cmbio
	if not auto_gear then
		if kev.confereTecla(kev.K_MARCHA, kev.PRESSED) then
			marcha = marcha + 1
			if marcha = 2 then marcha = 0
		end if
	else
		if marcha = 0 and rpm >= (64 / 400) then
			marcha = 1
		elseif marcha = 1 and rpm <= (24 / 400) then
			marcha = 0
		end if
	end if
	
	'volante
	x_center_reduce = x_center * ((0.5 - vel) / 0.5) * fps.getFator 'reduce with speed
	x_step_reduce = x_step * ((0.5 - vel) / 0.5) * fps.getFator
	
	if kev.confereTecla(kev.K_LEFT, kev.DOWN) then
		if accx > 0 then
			accx = accx - x_center_reduce
		else
			accx = accx - x_step_reduce
		end if
		
		if accx < (x_lock *  -1) then accx = x_lock * -1
	elseif kev.confereTecla(kev.K_RIGHT, kev.DOWN) then
		if accx < 0 then
			accx = accx + x_center_reduce
		else
			accx = accx + x_step_reduce
		end if
		
		if accx > x_lock then accx = x_lock
	else
		'centralizao com thresold
		if accx > x_step_reduce then
			accx = accx - x_center_reduce
		elseif accx < (x_step * -1) then
			accx = accx + x_center_reduce
		else
			accx = 0
		end if
	end if
	
	'pedais
	evt.setStatus evt.FREIO, false
	
	if kev.confereTecla(kev.K_DOWN, kev.DOWN) then
		acc = acc_max(1) * -1
		
		evt.setStatus evt.FREIO, true
	elseif kev.confereTecla(kev.K_UP, kev.DOWN) and not evt.getStatus(evt.GAME_OVER) then
		acc = acc_max(marcha) * 1
	else
		acc = 0
	end if
	
	'nitro
	if kev.confereTecla(kev.K_NITRO, kev.DOWN) and tempo_nitro = 0 and nitros > 0 then
		evt.setStatus evt.GASTA_NITRO, true
		tempo_nitro = 80
		nitros = nitros - 1
	end if
end sub

sub carro.fisica
	dim i as integer
	dim setor as string
		
	'acelerao
	vel = vel + (acc * fps.getFator)
		
	if tempo_nitro > 0 then
		vel = vel + (acc_max(marcha) * 0.2 * fps.getFator) '20% de boost
	
		tempo_nitro = tempo_nitro - (1 * fps.getFator)
	else
		tempo_nitro = 0
	end if
	
	vel = vel * (inercia(marcha) ^ fps.getFator)	
	if vel < 0 then vel = 0
		
	'rpm
	dim rpm_real as double
	rpm_real = vel / (acc_max(1) / acc_max(marcha))
	
	if rpm < rpm_real then
		rpm = rpm + (0.005 * fps.getFator)
		if rpm > rpm_real then rpm = rpm_real
	
	elseif rpm > rpm_real then
		rpm = rpm - (0.005 * fps.getFator)
		if rpm < rpm_real then rpm = rpm_real
	end if
		
	'coordenada
	last_coord = coord
	coord = coord + (vel * fps.getFator)
	
	'completa uma volta!
	if int(coord) > scn.tamanhoCircuito then
		coord = coord - scn.tamanhoCircuito
		last_coord = last_coord - scn.tamanhoCircuito
		
		evt.setStatus evt.COMPLETA_VOLTA, true
	else
		evt.setStatus evt.COMPLETA_VOLTA, false
	end if
	
	'what are you doing going backwards?
	if coord < 0 then
		coord = coord + scn.tamanhoCircuito
		last_coord = coord
	end if
	
	'setor
	setor = scn.getSetor(coord)
	
	'ngulo do horizonte e fora centrpeta
	select case setor
		case "l"
			ang = ang + (trk(scn.getCircuito).getAngStep * 2 * vel * fps.getFator)
			x = x + (0.4 * vel * fps.getFator)
		case "r"
			ang = ang - (trk(scn.getCircuito).getAngStep * 2 * vel * fps.getFator)
			x = x - (0.4 * vel * fps.getFator)
		case "a"
			ang = ang + (trk(scn.getCircuito).getAngStep * vel * fps.getFator)
			x = x + (0.2 * vel * fps.getFator)
		case "b"
			ang = ang - (trk(scn.getCircuito).getAngStep * vel * fps.getFator)
			x = x - (0.2 * vel * fps.getFator)
		case "c"
			ang = ang + (trk(scn.getCircuito).getAngStep * 3 * vel * fps.getFator)
			x = x + (0.6 * vel * fps.getFator)
		case "d"
			ang = ang - (trk(scn.getCircuito).getAngStep * 3 * vel * fps.getFator)
			x = x - (0.6 * vel * fps.getFator)
	end select
	
	if ang < 0 then ang = ang + 1
	if ang > 1 then ang = ang - 1
	
	'limiar de derrapagem
	limiar = x_lock * (vel_limiar / vel)
	if evt.getStatus(evt.GRAMA) then limiar = limiar * 0.6
	if steer_aid then limiar = limiar * 0.8 'penalizao por usar ajuda
	if limiar > (x_lock * 2) then limiar = x_lock * 2
	
	'curvatura
	if abs(accx) < limiar then
		evt.setStatus evt.DERRAPAGEM, false
		x = x + (accx * vel * fps.getFator)
		
		'perto do limiar: canta pneu sem derrapar
		if accx < (limiar * -0.6) or accx > (limiar * 0.6) then
			evt.setStatus evt.PRE_DERRAPAGEM, true
		else
			evt.setStatus evt.PRE_DERRAPAGEM, false
		end if
	else
		'passou do limiar: ajuda de controle
		if steer_aid then
			if accx < 0 then
				accx = limiar * -1
			else
				accx = limiar
			end if
			
			x = x + (accx * vel * fps.getFator)
		
		'understeer
		else
			evt.setStatus evt.PRE_DERRAPAGEM, false
			evt.setStatus evt.DERRAPAGEM, true
		end if		
	end if
	
	'derrapagem com acelerao
	if acc > 0 and vel < 0.05 and marcha = 0 and not evt.getStatus(evt.AUTO_PILOT) then
		evt.setStatus evt.PRE_DERRAPAGEM, false
		evt.setStatus evt.DERRAPAGEM, true
	end if
	
	'coliso com grama
	if abs(x) > 0.85 then
		vel = vel * (inercia(1) ^ fps.getFator)
		
		evt.setStatus evt.GRAMA, true
		
		if x > 0 and x < 1.15 then
			sfx_grama.setPan 1
		elseif x < 0 and x > -1.15 then
			sfx_grama.setPan -1
		else
			sfx_grama.setPan 0
		end if
	else
		evt.setStatus evt.grama, FALSE
	end if	
	
	'coliso com decoraes
	if abs(x) > 1.2 and abs(x) < 1.8 and frac(last_coord) > 0.5 and frac(coord) < 0.5 then
		coord = coord - 0.2
		if coord < 0 then coord = coord + scn.tamanhoCircuito
		
		evt.setStatus evt.COLISAO, true
	end if
	
	'coliso global (baseada em evento)
	if evt.getStatus(evt.COLISAO) then
		vel = 0
		rpm = 0
	elseif evt.getStatus(evt.BUMP) then
		vel = 0.07 'um pouco mais rpido que o computer car
		coord = coord + 0.25
	end if
	
	'coliso com nitro
	for i = 0 to (trk(scn.getCircuito).getNitros - 1)
		if last_coord < nit.getCoord(i) and coord >= nit.getCoord(i) and nit.getAtivo(i) then
			'range horizontal
			if abs(x - nit.getX(i)) < 0.28 and nitros < 9 then
				nitros = nitros + 1
				nit.setAtivo i, false
				
				evt.setStatus evt.COLETA_NITRO, true
			end if
		end if
	next
	
	'fim do mundo
	if x > 2 then x = 2
	if x < -2 then x = -2
	
	'fumaa de derrapagem
	if evt.getStatus(evt.DERRAPAGEM) and not evt.getStatus(evt.GRAMA) then
		fumaca_fade = 196
	elseif fumaca_fade > 0 then
		fumaca_fade = fumaca_fade - (20 * fps.getFator)
		
		if fumaca_fade < 0 then fumaca_fade = 0
	end if
end sub

sub carro.pintaSprite (x as integer)
	dim as integer quadro, x1, y
	
	if accx < -0.2 then
		quadro = 1
	elseif accx > 0.2 then
		quadro = 2
	else
		quadro = 0
	end if
	
	x1 = x - 50 - (accx * 10)
	y = 240 - 61
	
	if evt.getStatus(evt.GRAMA) and vel > 0.01 then y = y - int(rnd * 2)
	
	'farol noturno
	if trk(scn.getCircuito).noite then tela.pintaSprite farol, x1 + (accx * 20), y - 8, 48
	
	'o carro
	tela.pintaSprite sprite(quadro), x1, y
	
	'luz de freio
	if evt.getStatus(evt.FREIO) then pintaOverlay x1, y, quadro, 2
	
	'fogo no escape
	if tempo_nitro > 0 then pintaOverlay x1, y, quadro, (tempo_nitro mod 2)
	
	'derrapagem
	if fumaca_fade > 0 then
		if fumaca_fade = 196 then
			x1 = x1 - int(rnd * 2)
			y = y - int(rnd * 2)
		end if
	
		tela.pintaSprite fumaca, x1, y + 40, fumaca_fade
	end if
	
	'ngulo do volante (anteriormente parte de carro.hud, por isso tem que checar status)
	if not (evt.getStatus(evt.AUTO_PILOT) or evt.getStatus(evt.GAME_OVER)) then
		x1 = x + (55 * sin(accx))
		y = 228 - (52 * cos(accx))
	
		tela.pintaLinha x1, y - 1, x1, y - 1, &h000000
		tela.pintaLinha x1 - 1, y, x1 + 1, y, &h000000
		tela.pintaLinha x1 - 2, y + 1, x1 + 2, y + 1, &h000000
		tela.pintaLinha x1, y, x1, y, &h00b100
	end if
end sub

sub carro.pintaOverlay (x as integer, y as integer, quadro as integer, i as integer)
	dim luz as tupla
	dim as integer offset, transparencia
	dim as integer raio = 8
	
	if i < 2 then
		luz = mdl(mdl_index).getEscapamento
		transparencia = 255
	else
		luz = mdl(mdl_index).getLuzFreio
		transparencia = 128
	end if

	offset = mdl(mdl_index).getOffset
	
	if quadro = 2 then		'carro p/ esquerda
		offset = offset * -1
	elseif quadro = 0 then	'carro centrado
		offset = 0
	end if
	
	tela.pintaSprite overlay(i), x + luz.x + offset - raio, y + luz.y - raio, transparencia
	tela.pintaSprite overlay(i), x + (50 + (50 - luz.x)) + offset - raio, y + luz.y - raio, transparencia
	
	'faris da ferrari
	if i = 2 and mdl_index = mdl(0).FERRARI then
		luz.x = luz.x + 10
		
		tela.pintaSprite overlay(i), x + luz.x + offset - raio, y + luz.y - raio, transparencia
		tela.pintaSprite overlay(i), x + (50 + (50 - luz.x)) + offset - raio, y + luz.y - raio, transparencia
	end if
end sub

sub carro.pintaHUD
	dim as integer i, x, y
	dim as double r, g, b
	dim as uinteger cor
	dim t as string
	
	'velocmetro digital
	t = str(int(vel * 1750))
	if len(t) < 3 then t = string(3 - len(t), "0") + t
	fnt.pinta 9, 225, t, 5
	
	'velocmetro
	fnt.pinta 6, 197, "k[/]", 0, true
	
	i = vel * 100
	if i > 19 then i = 19
	tela.pintaSprite ponteiro_mask(0), 2, 206
	tela.pintaSprite ponteiro(i), 2, 206
		
	'indicador de marcha
	if auto_gear then
		t = "{}"
	elseif marcha = 0 then
		t = "lo"
	else
		t = "hi"
	end if
	fnt.pinta 46, 225, t, 0, true
	
	'tacmetro
	fnt.pinta 43, 197, "RPM", 0, true
		
	i = rpm * 90
	if i > 19 then i = 19
	tela.pintaSprite ponteiro_mask(1), 36, 206
	tela.pintaSprite ponteiro(i), 36, 206
			
	'contador de nitros
	t = "| * " + str(nitros)
	fnt.pinta 319 - (6 * len(t)), 230, t, 0, true
end sub

sub carro.carrega (bypass_efeitos as integer)
	dim as integer i, j
	dim as imagem folha_carros, ponteiro_buffer, overlay_buffer
	
	'cria imagens
	for i = 0 to 2
		sprite(i).cria 100, 60
	next
	
	'carrega e pinta carros
	folha_carros.carrega "gfx/car/carros.bmp"
	folha_carros.aplicaPalete 0, palete
		
	'recorta modelo
	sprite(0).copiaSprite folha_carros, 0, 60 * mdl_index, 99, (60 * mdl_index) + 59
	sprite(1).copiaSprite folha_carros, 100, 60 * mdl_index, 199, (60 * mdl_index) + 59
	
	'espelha pose de curva
	for i = 0 to 99
		for j = 0 to 59
			sprite(2).pintaLinha i, j, i, j, sprite(1).getPixel(99 - i, j)
		next
	next
	
	'no espelha cavalinho (coordenadas hard-coded)
	if mdl_index = 0 then
		for i = 49 to 56
			for j = 32 to 38
				sprite(2).pintaLinha i - 6, j, i - 6, j, sprite(1).getPixel(i, j)
			next
		next
	end if
	
	'efeito noite
	if trk(scn.getCircuito).noite and not bypass_efeitos then
		for i = 0 to 2
			sprite(i).efeitoSprite sprite(i).FX_ESCURECE, 0.5
		next
	end if
	
	'efeito nevoa
	if trk(scn.getCircuito).nevoa and not bypass_efeitos then
		for i = 0 to 2
			sprite(i).efeitoSprite sprite(i).FX_NEVOA, 1
		next
	end if
	
	'ponteiro do hud
	ponteiro_buffer.carrega "gfx/ponteiro.bmp"
	
	for i = 0 to 19
		ponteiro(i).cria 32, 32
		ponteiro(i).copiaSprite ponteiro_buffer, i * 32, 0, (i * 32) + 31, 31
	next
	
	ponteiro_buffer.carrega "gfx/ponteiro_mask.bmp"
	for i = 0 to 1
		ponteiro_mask(i).cria 32, 32
		ponteiro_mask(i).copiaSprite ponteiro_buffer, i * 32, 0, (i * 32) + 31, 31
	next
	
	'outros grficos
	overlay_buffer.carrega "gfx/car/overlay.bmp"
	
	for i = 0 to 2
		overlay(i).cria 16, 16
		overlay(i).copiaSprite overlay_buffer, i * 16, 0, (i * 16) + 15, 15
	next
	
	overlay_buffer.carrega "gfx/car/overlay2.bmp"
	
	farol.cria 100, 40
	farol.copiaSprite overlay_buffer, 0, 0, 99, 39
	
	fumaca.cria 100, 20
	fumaca.copiaSprite overlay_buffer, 0, 40, 99, 59
	if trk(scn.getCircuito).noite then fumaca.efeitoSprite fumaca.FX_ESCURECE, 0.5
	
	'apaga buffers temporrios
	folha_carros.destroi
	ponteiro_buffer.destroi
	overlay_buffer.destroi
end sub

sub carro.carrega
	carrega false
end sub

sub carro.destroi
	dim i as integer
	
	for i = 0 to 2
		sprite(i).destroi
		overlay(i).destroi
	next
	
	for i = 0 to 19
		ponteiro(i).destroi
	next
	ponteiro_mask(0).destroi
	ponteiro_mask(1).destroi
	
	fumaca.destroi
	farol.destroi
end sub

'-----------------------------------------------------------------------
function listacc.getCoord (i as integer) as double
	if i > max_itens then
		print "acesso a CC fora do array!"
		return -1
	else	
		return item(i).coord
	end if
end function

function listacc.getX (i as integer) as double
	return item(i).x
end function

function listacc.getMaxItens () as integer
	return max_itens
end function

sub listacc.spawn
	dim as integer i, cc_count
	
	i = 0
	cc_count = 0
	
	'espalha pela pista
	do
		i = i + int(rnd * 8) + 4 'intervalo aleatrio
		if i >= scn.tamanhoCircuito then exit do
		
		item(cc_count).coord = i
		item(cc_count).vel = 0.06
		item(cc_count).x = ((rnd * 2) - 1) * 0.8
		item(cc_count).accx = ((rnd * 2) - 1) * 0.02
		item(cc_count).timeout = 0
		
		if cc_count < MAX_CC then cc_count = cc_count + 1
	loop
	
	max_itens = cc_count - 1
end sub

sub listacc.processa
	dim as single largura = 0.075
	dim i as integer
		
	for i = 0 to max_itens
		'coordenada
		item(i).last_coord = item(i).coord
		
		item(i).coord = item(i).coord + (item(i).vel * fps.getFator)
		
		'completa uma volta
		if int(item(i).coord) > scn.tamanhoCircuito then
			item(i).coord = item(i).coord - scn.tamanhoCircuito
			item(i).last_coord = item(i).last_coord - scn.tamanhoCircuito
		end if
	
		'curvatura
		item(i).x = item(i).x + (item(i).accx * fps.getFator)
		if item(i).x < -0.85 then
			item(i).x = -0.85
			item(i).accx = item(i).accx * -1
		elseif item(i).x > 0.85 then
			item(i).x = 0.85
			item(i).accx = item(i).accx * -1
		end if
	
		'coliso
		if item(i).timeout = 0 then
			'jogador ultrapassa dummy
			if car.getLastCoord < item(i).last_coord and car.getCoord >= (item(i).coord - largura) then
				'range horizontal
				if abs(car.getX - item(i).x) < 0.32 then
					evt.setStatus evt.COLISAO, true
					item(i).timeout = 10
				else
					evt.setStatus evt.ULTRAPASSAGEM, true
					sfx_ultrapassagem.setPan item(i).x - car.getX
				end if
				
			'dummy ultrapassa o jogador
			elseif item(i).last_coord < car.getLastCoord and item(i).coord >= car.getCoord then
				'range horizontal
				if abs(car.getX - item(i).x) < 0.32 then
					evt.setStatus evt.BUMP, true
					item(i).timeout = 10
				else
					evt.setStatus evt.ULTRAPASSAGEM, true
					sfx_ultrapassagem.setPan item(i).x - car.getX
				end if
			end if
		else
			item(i).timeout = item(i).timeout - 1
		end if
	next
end sub

'-----------------------------------------------------------------------
function nitros.getCoord (i as integer) as double
	if i > max_itens then
		print "acesso a nitro fora do array!"
		return -1
	else	
		return coord(i)
	end if
end function

function nitros.getX (i as integer) as double	
	return x(i)
end function

function nitros.getAtivo (i as integer) as integer	
	return ativo(i)
end function

sub nitros.setAtivo (i as integer, ativo as integer)
	this.ativo(i) = ativo
end sub

function nitros.getMaxItens () as integer
	return max_itens
end function

sub nitros.spawn (nova_corrida as integer)
	dim as integer i, nitro_count
	nitro_count = 0
	
	while nitro_count <= (trk(scn.getCircuito).getNitros - 1)
		if nova_corrida or not ativo(nitro_count) then
			x(nitro_count) = ((rnd * 2) - 1) * 0.8
			coord(nitro_count) = (rnd * (scn.tamanhoCircuito - 10)) + 10
			ativo(nitro_count) = true
		end if
		
		nitro_count = nitro_count + 1
	wend

	max_itens = nitro_count - 1
end sub

'-----------------------------------------------------------------------
function circuito.mirror (s as string) as string
	dim i as integer
	
	dim s2 as string
	s2 = ""
	
	for i = 1 to len(s)
		select case mid(s, i, 1)
			case "l": s2 = s2 + "r"
			case "r": s2 = s2 + "l"
			
			case "a": s2 = s2 + "b"
			case "b": s2 = s2 + "a"
			
			case "c": s2 = s2 + "d"
			case "d": s2 = s2 + "c"
			
			case else: s2 = s2 + mid(s, i, 1)
		end select
	next
	
	return s2
end function

function circuito.reverse (s as string) as string
	dim i as integer
	
	dim s2 as string
	s2 = "x"
	
	for i = len(s) to 2 step -1
		s2 = s2 + mid(s, i, 1)

	next
	
	return mirror(s2)
end function

sub circuito.calculaAngStep
	'# rotina para calcular a velocidade tal qual o horizonte esteja sempre no mesmo ngulo em todas as voltas 
	dim as integer i, total_dir, total_esq, dif
	
	total_esq = 0
	total_dir = 0
	
	for i = 1 to len(s)
		select case mid(s, i, 1)
			case "a": total_esq = total_esq + 1
			case "b": total_dir = total_dir + 1
			case "l": total_esq = total_esq + 2
			case "r": total_dir = total_dir + 2
			case "c": total_esq = total_esq + 3
			case "d": total_dir = total_dir + 3
		end select
	next
	
	dif = abs(total_esq - total_dir)
	
	if dif = 0 then
		ang_step = 0.03 'default para circuitos em "8"
	else
		ang_step = 1 / dif
	end if
	
	'efeito warp: d duas voltas em vez de uma (causa tearing muito ntido)
	if OUTRUN_WARP then ang_step = ang_step * 2
	
	'cospe valores de debug pro terminal
	print "("; nome; ")"
	print "curvas esquerda: "; total_esq
	print "curvas direita: "; total_dir
	print "diferenca: "; dif
	print "valor: "; ang_step	
end sub

function circuito.getNome () as string
	return nome
end function

function circuito.getNomeCompleto () as string
	return nome_completo
end function

function circuito.getRecorde () as double
	return recorde
end function

function circuito.getRecordeVoltas () as integer
	return recorde_voltas
end function

function circuito.getMedia () as double
	return media
end function

function circuito.getDificuldade () as double
	return dificuldade
end function

function circuito.getNitros () as integer
	return nitros
end function

function circuito.getAngStep () as double
	return ang_step
end function

function circuito.getGrama () as uinteger
	return grama
end function

function circuito.getMar () as tupla
	dim m as tupla
	
	if index = CITY then
		m.x = mar.x
		m.y = mar.y
	else
		m.x = -1
		m.y = -1
	end if
	
	return m
end function

function circuito.noite () as integer
	return index = NIGHT
end function

function circuito.neve () as integer
	return index = ALPINE
end function

function circuito.nevoa () as integer
	return index = FOG
end function

function circuito.getSetores (orientacao as integer) as string
	select case orientacao
		case 0: return s
		case 1: return mirror(s)
		case 2: return reverse(s)
		case 3: return mirror(reverse(s))
	end select
end function

sub circuito.cria (i as integer)
	'### SETORES ###
	'X: linha de chegada
	'S: reta
	'T: tnel
	'A < > B: curva leve
	'L < > R: curva
	'C < > D: curva fechada
	'F: ponto de freada
	'P: placa de publicidade

	'povoa objeto com dados	
	select case i
		case SUBURBAN:
			nome = "suburban"
			nome_completo = "curso suburbano"
			s = "xsssssssfscccrrrraaaaaaaaaaaaaasssssspspspspsfsllllllssaaaaasssssspsrrrrrrsssbbbbsfsrrrrllllllllrrrrsfsddddddsssssslllllpspsfsccccssssssssaaaaassssssssssaaasspppp"
			grama = &h4f573e
			media = 0.08
			dificuldade = 0.97
			nitros = 3
			
		case MOUNTAIN:
			nome = "mountain"
			nome_completo = "curso das montanhas"
			s = "xssssssssssfsrrrrrsssrrrrspsplllsrrrsllllsrrrrssaaaaaaaaaaaaspspsprrrrssssfsddddssstttsssbbbbbsfsccccccssssssbbbbbbbbssssssfsllllllsslllllsssssssssssssssssspsccssssssssfsdddscccssssbbbbbbbssspppp"
			grama = &h6a755a
			media = 0.08
			dificuldade = 0.97
			nitros = 3
			
		case CITY:
			nome = "city"
			nome_completo = "curso urbano"
			s = "xppbbbbbsfadddsssssbbbbssaaaaassbbbbssslllllllssdddpspspspsfsdddbbaasfsccccccccssssdddsssdddsssspttttttttttttttttttssbbfscccdddsssssspscccsssssccsddssssddsccsssaaafddddsddsssssrraassssssbbbbbpp"
			grama = &h50573e
			mar.x = 91
			mar.y = 165
			media = 0.076
			dificuldade = 0.97
			nitros = 3
		
		case DESERT:
			nome = "desert"
			nome_completo = "curso do deserto"
			s = "xsssssssssssllllllaaaaaaaaaaspspspspspspspsaaaaaaaaaallllllssssssssssss"
			grama = &h716949
			media = 0.07
			dificuldade = 0.95
			nitros = 1
		
		case ALPINE:
			nome = "alpine"
			nome_completo = "curso alpino"
			s = "xssssssssfsdddddddbbaasssspsccsssspsccssssfsccccssssssbbbbbbsssfsrrrrrrrrrrrsssssssspsllrrssssssssssssssaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaasssssttttttsssssbbbbbbsssspppp"
			grama = &hb7b7b7
			media = 0.076
			dificuldade = 0.97
			nitros = 3
		
		case NIGHT:
			nome = "night"
			nome_completo = "curso noturno"
			s = "xspspspspbbbbsssssssssssstttsfsddddddssstttssssssssfslllllldddssssssssfsdddssdddsssssssplllllllaaaaassssssssaaaasssssssfsdddssssdddssssssssbbbbsspspspspsps"
			grama = &h080808
			media = 0.076
			dificuldade = 0.97
			nitros = 2
	
		case FOG:
			nome = "fog"
			nome_completo = "curso da nvoa"
			s = "xssssssssssssssppppssssssssssssssbbbbbbbbbbbbbbbbbbbbbbbbbblllttttttttttttttttttrrrrsssaaaaaarrrrssssfsddddddssssssssssfsccccccccsssssssssssssssprrrrrrrddssssssssssssss"
			grama = tela.efeitoCor(0, tela.FX_NEVOA, 255)
			media = 0.078
			dificuldade = 0.97
			nitros = 3
		
		case else:
			nome = "delete_me"
			nome_completo = "out of range!"
	end select
	
	index = i
	calculaAngStep
	carregaRecordes
	carregaMapa
end sub

sub circuito.carregaRecordes
	open "hig/" + nome for binary access read as #1
		if eof(1) then
			recorde = 60000
			recorde_voltas = 0
		else
			get #1, , recorde
			get #1, , recorde_voltas
		end if
	close
	
	print "< recordes: "; recorde; " "; recorde_voltas
end sub

sub circuito.salvaRecordes
	dim as integer escreve = false

	if tmp.getMS(tmp.RECORDE) < recorde then
		recorde = tmp.getMS(tmp.RECORDE)
		escreve = true
	end if
	if tmp.getRecordeVoltas > recorde_voltas then
		recorde_voltas = tmp.getRecordeVoltas
		escreve = true
	end if
	
	if escreve then
		open "hig/" + nome for binary access write as #1
			put #1, , recorde
			put #1, , recorde_voltas
		close
		
		print "> recordes: "; recorde; " "; recorde_voltas
	end if
end sub

sub circuito.carregaMapa
	dim as integer i, j, r
	dim mapa_buffer as imagem
	dim cor as uinteger

	'carrega bitmap
	mapa.carrega "gfx/map/" + nome + ".bmp"
	
	'recorta bandeira
	bandeira.cria 14, 9
	bandeira.copiaSprite mapa, 0, 0, 13, 8
	mapa.pintaLinha 0, 0, 13, 8, &hff00ff
	
	'cria mapa pequeno
	mapa_buffer.cria 80, 80
		
	'scaling simples
	for i = 0 to 79
		for j = 0 to 79
			mapa_buffer.pintaPixel i, j, mapa.getPixel(i * 2, j * 2)
		next
	next

	'copia no fundo colorido
	mapa_peq.cria 80, 80
	if noite then
		mapa_peq.pintaLinha 0, 0, 79, 79, &h666666
	else
		mapa_peq.pintaLinha 0, 0, 79, 79, grama
	end if
	mapa_peq.pintaSprite mapa_buffer, 0, 0
	
	'libera buffer
	mapa_buffer.destroi
end sub

sub circuito.pintaMapa (x as integer, y as integer)
	tela.pintaSprite mapa_peq, x, y
end sub

sub circuito.preview
	'grficos
	dim fundo as imagem
	fundo.carrega "gfx/scr/preview.bmp"
	
	tela.pintaSprite fundo, 0, 0
	tela.pintaSprite bandeira, 10, 08
	tela.pintaSprite bandeira, 295, 08
	tela.pintaSprite mapa, 79, 34
		
	'texto
	fnt.pinta -1, 07, nome_completo, 1
	fnt.pinta -1, 08, string(len(nome_completo), "_"), 1 'faz underline
	
	fnt.pinta -1, 25, "comprimento: " + str(len(s) * 25) + "[", 1
	
	fnt.pinta -1, 195, "tempo recorde", 1
	fnt.pinta -1, 204, tmp.formata(recorde), 5
	
	fnt.pinta -1, 222, "recorde de voltas em modo arcade: " + str(recorde_voltas), 1
	
	tela.atualiza
	
	'espera input
	kev.esperaTecla
	
	'libera memria
	fundo.destroi
end sub

sub circuito.destroi
	mapa.destroi
	bandeira.destroi
end sub 

'-----------------------------------------------------------------------
sub cena.carregaTextura (i as integer, arquivo as string)
	dim as integer m, n
		
	dim textura_buffer as imagem
	textura_buffer.carrega arquivo
	
	for m = 0 to 99
		for n = 0 to 23
			'mapeia bitmap para array
			if not (orientacao = 1 or orientacao = 2) then
				textura(i, m, n) = textura_buffer.getPixel(m, n)
			else
				textura(i, 99 - m, n) = textura_buffer.getPixel(m, n)
			end if
		next
	next			
	
	textura_buffer.destroi
end sub

sub cena.graficos
	type camType
		coord as double
		last_coord as double
		warp as double 'distoro de objetos em distncia
		perspec as double 'ngulo de perspectiva
		desloc as double 'deslocamento horizontal
		dist as double 'distncia de perseguio
	end type
	
	type pistaType
		larg as double
		eixo as double
		x1 as double
		x2 as double
	end type
	
	type curvaType
		ang as double
		passo as double
	end type
		
	type marType
		coords as tupla
		shade(0 to 3) as uinteger
	end type
	
	dim pilha as pilhasprites
	dim cam as camType
	dim pista as pistaType
	dim curva as curvaType
	dim mar as marType
	dim ghost_coord as double
					
	'inicializa variveis
	ghost_coord = getGhostCoord
	cam.perspec = 5.4 / 4
	cam.desloc = 0.95
	cam.dist = 0.5
	cam.coord = car.getCoord - cam.dist + tamanhoCircuito
	cam.last_coord = -1
	pista.larg = 500
	pista.eixo = 160 - (car.getX * (pista.larg / 2) * cam.desloc)
	curva.ang = 0
	curva.passo = 0
	
	'mar
	mar.coords = trk(trk_index).getMar
	
	if mar.coords.x > -1 then
		'define cores
		mar.shade(0) = &h4f5573
		mar.shade(1) = &h5f6583
		mar.shade(2) = &h6b6b90
		mar.shade(3) = &h7b7ba0
		
		'reverte coordenadas de incio e fim
		if orientacao = 2 or orientacao = 3 then
			dim as integer x_temp
			x_temp = mar.coords.x
			
			mar.coords.x = tamanhoCircuito - mar.coords.y
			mar.coords.y = tamanhoCircuito - x_temp
		end if
	end if
	
	'background
	tela.pintaLinha 0, 0, 319, 43, ceu 
		
	tela.pintaSprite nuvens, 320 * car.getAng, 44
	tela.pintaSprite nuvens, (320 * car.getAng) - 320, 44
	tela.pintaSprite horizonte, 320 * car.getAng, 110
	tela.pintaSprite horizonte, (320 * car.getAng) - 320, 110
	
	'neve background
	if trk(trk_index).neve then efeitoNeve 1
			
	'pista
	dim as string setor, oldSetor
	dim as double i, j, tam
		
	setor = getSetor(cam.coord)
			
	for i = 240 to 150 step -0.25 'coordenada absoluta dos pixels
		'atualiza estado
		pista.larg = pista.larg - cam.perspec
		pista.eixo = pista.eixo + ((car.getX * cam.desloc * 125 / 2) / 90) 'quarto da pista.larg original / nmero de linhas
			
		tam = pista.larg / 2
		pista.x1 = pista.eixo - tam
		pista.x2 = pista.eixo + tam
		
		'y em perspectiva
		if (not OUTRUN_WARP) or (i > 180) then
			cam.warp = 1
		else
			cam.warp = 1 - ((180 - i) / 180)
		end if
		cam.coord = car.getCoord - cam.dist + ((1 / pista.larg) * i * cam.warp)
		
		if int(cam.coord) < 0 then cam.coord = cam.coord + tamanhoCircuito		
		if int(cam.coord) > tamanhoCircuito then cam.coord = cam.coord - tamanhoCircuito
					
		oldSetor = setor
		setor = getSetor(cam.coord)
	
		'curva
		curva.ang = ((1 / pista.larg) * i) ^ 3
		
		select case setor
			case  "l": curva.ang = curva.ang / -320
			case  "r": curva.ang = curva.ang /  320
			case  "a": curva.ang = curva.ang / -640
			case  "b": curva.ang = curva.ang /  640
			case  "c": curva.ang = curva.ang / -200
			case  "d": curva.ang = curva.ang /  200
			case else: curva.ang = 0
		end select
				
		curva.passo = curva.passo + curva.ang
		pista.eixo = pista.eixo + curva.passo
		
		'decoraes
		if cam.last_coord = -1 then
			cam.last_coord = cam.coord
		elseif frac(cam.last_coord) >= 0.5 and frac(cam.coord) < 0.5 then
			select case getSetor(cam.last_coord)
				'sinal
				case "x"
					pilha.push 2, pista.x1 - (tam / 2), i, tam / 2
					pilha.push 2, pista.x2 + (tam / 2), i, tam / 2
				
				'colunas / pseudo tnel
				case "t"
					if car.getX < 0 then 'liga o topo  pilastra mais prxima do jogador
						pilha.push 3, pista.x1 - (tam / 2), i, tam / 2, true
						pilha.push 3, pista.x2 + (tam / 2), i, tam / 2, false
					else
						pilha.push 3, pista.x1 - (tam / 2), i, tam / 2, false
						pilha.push 3, pista.x2 + (tam / 2), i, tam / 2, true
					end if
				
				'barreiras de pneu
				case "l", "a", "c"
					pilha.push 0, pista.x1 - (tam / 2), i, tam / 2
					pilha.push 1, pista.x2 + (tam / 2), i, tam / 2
				
				case "r", "b", "d"
					pilha.push 1, pista.x1 - (tam / 2), i, tam / 2
					pilha.push 0, pista.x2 + (tam / 2), i, tam / 2
				
				'placa de freada
				case "f"
					if not (orientacao = 1 or orientacao = 2) then
						pilha.push 6, pista.x1 - (tam / 2), i, tam / 2
						pilha.push 4, pista.x2 + (tam / 2), i, tam / 2
					else
						pilha.push 4, pista.x1 - (tam / 2), i, tam / 2
						pilha.push 6, pista.x2 + (tam / 2), i, tam / 2
					end if
				
				'placa de publicidade
				case "p"
					pilha.push 5, pista.x1 - (tam / 2), i, tam / 2
					pilha.push 5, pista.x2 + (tam / 2), i, tam / 2
		
				'rvores
				case else
					pilha.push 0, pista.x1 - (tam / 2), i, tam / 2
					pilha.push 0, pista.x2 + (tam / 2), i, tam / 2
			end select
		end if
		
		'nitros
		for j = 0 to nit.getMaxItens
			if cam.last_coord < nit.getCoord(j) and cam.coord >= nit.getCoord(j) and nit.getAtivo(j) then
				pilha.push 7, pista.eixo + (tam * nit.getX(j)), i, tam / 2
			end if
		next
		
		'computer cars
		for j = 0 to cc.getMaxItens
			if cam.last_coord < cc.getCoord(j) and cam.coord >= cc.getCoord(j) then
				pilha.push 10 + j + 1, pista.eixo + (tam * cc.getX(j)), i, tam * 0.3
			end if
		next
		
		'ghost car
		if cam.last_coord < ghost_coord and cam.coord >= ghost_coord then
			pilha.push 10, pista.eixo, i, tam * 0.3
		end if	
				
		cam.last_coord = cam.coord
	
		'pinta
		if frac(i) = 0 then
			'grama
			texturizaGrama pista.x1 - 1, -1, i, cam.coord, pista.x2 - pista.x1
			texturizaGrama pista.x2 + 1, +1, i, cam.coord, pista.x2 - pista.x1
		
			'mar
			if mar.coords.x > -1 then
				dim faixa as integer
				select case frac(cam.coord)
					case is < 0.125: faixa = 0
					case 0.125 to 0.25: faixa = 1
					case 0.25 to 0.375: faixa = 2
					case 0.375 to 0.625: faixa = 3
					case 0.625 to 0.75: faixa = 2
					case 0.75 to 0.875: faixa = 1
					case is > 0.875: faixa = 0 
				end select
				
				if cam.coord >= mar.coords.x and cam.coord <= mar.coords.y then
					if not (orientacao = 1 or orientacao = 2) then
						if pista.x1 - tam >= 0 then	tela.pintaLinha 0, i, pista.x1 - tam, i, mar.shade(faixa)
					else
						if pista.x2 + tam <= 319 then tela.pintaLinha pista.x2 + tam, i, 319, i, mar.shade(faixa)
					end if
				end if
			end if
		
			'asfalto
			texturizaPista pista.x1, pista.x2, i, cam.coord, setor
		end if
	next
	
	'sprites da pista
	dim spr as sprite3d
	
	while pilha.naoVazia
		spr = pilha.pop
		
		if spr.i < 10 then
			decor(spr.i).pintaDecor spr
		elseif spr.i = 10 then
			ghost.pintaCC spr, 128
		else
			cc_gfx.pintaCC spr
		end if
	wend
	
	'sprite do jogador
	car.pintaSprite 160 + (car.getX * 250 * (1 - cam.desloc))
	
	'neve foreground
	if trk(trk_index).neve then efeitoNeve 0
end sub

sub cena.texturizaPista (x1 as integer, x2 as integer, i as integer, y as double, setor as string)
	dim as integer tex_x, tex_y, tex_i, detalhe, xp, yp, efeito, brilho
	dim as double passo, x
	
	'otimizaes de vdeo
	dim as integer offset, pitch, bpp
	pitch = tela.getPitch
	bpp = tela.getBPP
	
	passo = (x2 - x1) / 100
	detalhe = 1
	tex_y = (int(y * 24)) mod 24
	tex_x = 0
	yp = i * pitch
		
	'qual textura?
	select case setor
		case "l", "r", "a", "b", "c", "d"
			tex_i = 1
		case "x"
			tex_i = 2
		case else
			tex_i = 0
	end select
	
	if setor = "t" and getSetor(y - 1) = "t" then tex_i = 4 'tnel
	
	'diminui detalhe na distncia
	if i < 157 then
		detalhe = 4
		passo = passo * 4
	elseif i < 160 then
		detalhe = 2
		passo = passo * 2
	end if
	
	'aplica algum efeito?
	if trk(trk_index).nevoa then
		efeito = tela.FX_NEVOA
	elseif trk(trk_index).noite then
		efeito = tela.FX_ESCURECE
	else
		efeito = tela.FX_NULL
	end if	
	
	'calcula brilho reduzido
	if efeito <> tela.FX_NULL then
		if i < 200 then
			brilho = (200 - i) ^ 1.42
		elseif efeito = tela.FX_ESCURECE then
			brilho = (i - 200) ^ 1.42
		else
			efeito = tela.FX_NULL
		end if
		
		if brilho < 0 then efeito = tela.FX_NULL
		if brilho > 255 then brilho = 255
	end if
	
	'pinta plano
	if lod = 0 then
		dim as double tam
		tam = (x2 - x1) / 100
	
		'asfalto
		if tex_y < 12 then
			tela.pintaLinha x1, i, x2, i, tela.efeitoCor(&h707070, efeito, brilho)
		else
			tela.pintaLinha x1, i, x2, i, tela.efeitoCor(&h606060, efeito, brilho)
		end if
		
		'faixas laterais
		tela.pintaLinha x1 + (6 * tam), i, x1 + (9 * tam), i, tela.efeitoCor(&heeeeee, efeito, brilho)
		tela.pintaLinha x1 + (91 * tam), i, x1 + (94 * tam), i, tela.efeitoCor(&heeeeee, efeito, brilho)
		
		'faixa central
		if (tex_y mod 12) < 6 then
			tela.pintaLinha x1 + (49 * tam), i, x1 + (51 * tam), i, tela.efeitoCor(&hfce94f, efeito, brilho)
		end if
		
		'linha de chegada
		if setor = "x" and tex_y < 6 then
			tela.pintaLinha x1 + (8 * tam), i, x1 + (91 * tam), i, tela.efeitoCor(&heeeeee, efeito, brilho)
		end if
		
		exit sub
	end if
	
	'pinta
	x = x1
	
	if x2 < 0 or x1 >= 320 or i >= 240 then
		'nada pra desenhar!
		exit sub
	elseif x < 0 then
		while (x + passo) < 0
			x = x + passo
			tex_x = tex_x + detalhe
		wend
	
		'unoptimized
		tela.pintaLinha x, i, x + passo, i, tela.efeitoCor(textura(tex_i, tex_x, tex_y), efeito, brilho)
	end if
	
	while tex_x <= 99
		for xp = x to x + passo
			if xp >= 320 then exit sub
					
			offset = yp + (xp * bpp)
			tela.pintaPixel offset, tela.efeitoCor(textura(tex_i, tex_x, tex_y), efeito, brilho)
		next
		
		x = x + passo
		tex_x = tex_x + detalhe
	wend
end sub

sub cena.texturizaGrama (x1 as integer, sentido as integer, i as integer, y as double, tam as integer)
	dim as integer tex_x, tex_y, tex_i, detalhe, xp, yp, x2
	dim as double passo, x
	
	'otimizaes de vdeo
	dim as integer offset, pitch, bpp
	pitch = tela.getPitch
	bpp = tela.getBPP
	
	if sentido = 1 then
		x2 = 319
	else
		x2 = 0
	end if
	
	'pinta plano
	if lod < 2 then
		if x1 < x2 then
			tela.pintaLinha x1, i, x2, i, trk(trk_index).getGrama
		else
			tela.pintaLinha x2, i, x1, i, trk(trk_index).getGrama
		end if
		
		exit sub
	end if
	
	passo = tam / 100 * sentido
	detalhe = 1
	tex_y = (int(y * 24)) mod 24
	tex_x = 0
	tex_i = 3
	yp = i * pitch
	
	'diminui detalhe na distncia
	if i < 157 then
		detalhe = 4
		passo = passo * 4	
	elseif i < 160 then
		detalhe = 2
		passo = passo * 2
	end if
	
	'pinta
	x = x1
	
	if (sentido = -1 and x1 < x2) or (sentido = 1 and x1 > x2) or i >= 240 then
		'nada pra desenhar!
		exit sub
	end if
			
	if sentido = -1 then
		if x > 319 then
			while x > 319
				x = x + passo
				tex_x = tex_x + detalhe
				if tex_x > 99 then tex_x = tex_x - 100
			wend
			
			'unoptimized
			tela.pintaLinha x, i, x + passo, i, textura(tex_i, tex_x, tex_y)
		end if
		
		do
			for xp = x to x + passo step sentido
				if xp < x2 then exit sub
		
				offset = yp + (xp * bpp)
				tela.pintaPixel offset, textura(tex_i, tex_x, tex_y)
			next
			
			x = x + passo
			tex_x = tex_x + detalhe
			if tex_x > 99 then tex_x = tex_x - 100
		loop
	else
		if x < 0 then
			while (x + passo) < 0
				x = x + passo
				tex_x = tex_x + detalhe
				if tex_x > 99 then tex_x = tex_x - 100
			wend
			
			'unoptmized
			tela.pintaLinha x, i, x + passo, i, textura(tex_i, tex_x, tex_y)
		end if
	
		do
			for xp = x to x + passo step sentido
				if xp > x2 then exit sub
			
				offset = yp + (xp * bpp)
				tela.pintaPixel offset, textura(tex_i, tex_x, tex_y)
			next
			
			x = x + passo
			tex_x = tex_x + detalhe
			if tex_x > 99 then tex_x = tex_x - 100
		loop
	end if
end sub

sub cena.efeitoNeve (i as integer)
	dim as integer m, n, x, y
	
	'detalhe grfico baixo
	if lod < 2 then exit sub
	
	'calcula posio/velocidade da neve
	if i = 0 then
		x = 20
	else
		x = 5
	end if
	x = x * sin(tmp.getMS(tmp.TOTAL) / 1000)
	y = (tmp.getMS(tmp.TOTAL) mod (1150 * (i + 1))) / (25 * (i + 1))
	
	'pinta
	for m = -45 to 339 step 46
		for n = -45 to 239 step 46
			tela.pintaSprite neve(i), m + x, n + y, 96
		next
	next 
end sub

function cena.getGhostCoord () as double
	if game_mode = GM_ARCADE then
		if evt.getStatus(evt.GAME_OVER) or tmp.getVolta = 0 or tmp.getMS(tmp.VOLTA) = 0 then
			return tamanhoCircuito + 1
		else
			return 1 + (tamanhoCircuito * (tmp.getMS(tmp.VOLTA) / tmp.getMS(tmp.META)))
		end if
	else
		if tmp.getVolta > 1 then
			return 1 + (tamanhoCircuito * (tmp.getMS(tmp.VOLTA) / tmp.getMS(tmp.MELHOR)))
		else
			return -1
		end if
	end if
end function

function cena.getCircuito () as integer
	return trk_index
end function

sub cena.setCircuito (trk_index as integer)
	this.trk_index = trk_index
end sub

function cena.getOrientacao () as integer
	return orientacao
end function

sub cena.setOrientacao (orientacao as integer)
	this.orientacao = orientacao
end sub

function cena.getGameMode () as integer
	return game_mode
end function

sub cena.setGameMode (game_mode as integer)
	this.game_mode = game_mode
end sub

function cena.getLOD () as integer
	return lod
end function

sub cena.setLOD (lod as integer)
	this.lod = lod
end sub

function cena.getSFXOn () as integer
	return sfx_on
end function

sub cena.setSFXOn (sfx_on as integer)
	this.sfx_on = sfx_on
end sub

function cena.getSetor (coord as double) as string
	return mid(s, int(coord), 1)
end function

function cena.tamanhoCircuito () as integer
	return len(s)
end function

sub cena.cria
	dim as integer i, j

	'copia setores
	s = trk(trk_index).getSetores(orientacao)
	 
	'reinicia objetos
	evt.reinicia
	tmp.reinicia
	fps.reinicia
	car.reinicia
	nit.spawn true 'nova corrida
	cc.spawn	 
	 
	'carros
	car.carrega
	if car.getPalete < 7 then
		cc_gfx.carregaCC car.getModelo, 7
	else
		cc_gfx.carregaCC car.getModelo, 5
	end if
	ghost.carregaCC car.getModelo, car.getPalete
	 
	'decoraes
	decor(0).carregaDecor "gfx/spr/arvore"
	decor(1).carregaDecor "gfx/spr/pneu"
	decor(2).carregaDecor "gfx/spr/sinal"
	decor(3).carregaDecor "gfx/spr/coluna"
	if not (orientacao = 1 or orientacao = 2) then
		decor(4).carregaDecor "gfx/spr/freada"
	else
		decor(4).carregaDecor "gfx/spr/freada_m"
	end if
	decor(5).carregaDecor "gfx/spr/placa"
	decor(6).carregaDecor "gfx/spr/fiscal"
	decor(7).carregaDecor "gfx/spr/nitro"
	
	'texturas
	carregaTextura 0, "gfx/tex/pista.bmp"
	carregaTextura 1, "gfx/tex/zebra_" + trk(trk_index).getNome + ".bmp"
	carregaTextura 2, "gfx/tex/linha.bmp"
	carregaTextura 3, "gfx/tex/solo.bmp"
	carregaTextura 4, "gfx/tex/tunel.bmp"
		
	'colore grama
	for i = 0 to 99
		for j = 0 to 24
			textura(3, i, j) = trk(trk_index).getGrama - textura(3, i, j) + &h080808
		next
	next
		
	'fundo
	if trk(trk_index).nevoa then
		nuvens.cria 320, 100
		nuvens.pintaLinha 0, 0, 319, 99, nuvens.efeitoCor(0, nuvens.FX_NEVOA, 255)
	elseif trk(trk_index).noite then
		nuvens.carrega "gfx/bg/noite.bmp"
	elseif trk(trk_index).neve then
		nuvens.carrega "gfx/bg/neve.bmp"
	else
		nuvens.carrega "gfx/bg/nuvens.bmp"
	end if
	ceu = nuvens.getPixel(0, 0)
	
	'horizonte
	if trk(trk_index).nevoa then
		horizonte.cria 320, 40
		horizonte.pintaLinha 0, 0, 319, 39, horizonte.efeitoCor(0, nuvens.FX_NEVOA, 255)
	else
		horizonte.carrega "gfx/hor/" + trk(trk_index).getNome + ".bmp"
	end if
	
	'neve
	dim neve_buffer as imagem
	neve_buffer.carrega "gfx/neve.bmp"
	
	for i = 0 to 1
		neve(i).cria 46, 46
		neve(i).copiaSprite neve_buffer, i * 46, 0, (i * 46) + 45, 45
	next
	
	neve_buffer.destroi
	
	'sons
	iniciaSons
end sub

sub cena.destroi ()
	dim as integer i
	
	paraSons
	
	car.destroi
	cc_gfx.destroi
	ghost.destroi
	nuvens.destroi
	horizonte.destroi
	
	for i = 0 to MAX_DECORS
		decor(i).destroi
	next
	
	for i = 0 to 2
		neve(i).destroi
	next
end sub

sub cena.gameLoop ()
	dim as integer retorna = false
	dim as integer i, cor
	dim t as string
	
	'vozes contagem regressiva
	dim as integer voc_tocou(0 to 3)
	for i = 0 to 3
		voc_tocou(i) = false
	next

	'modos de jogo e estados relacionados
	if game_mode = GM_ARCADE then
		evt.setStatus evt.AUTO_PILOT, true
	elseif game_mode = GM_DEMO then
		evt.setStatus evt.AUTO_PILOT, true
		evt.setStatus evt.GAME_OVER, true
	end if
	
	do
		fps.atualiza
	
		'atualiza algumas variveis
		evt.setStatus evt.COLISAO, false
		evt.setStatus evt.BUMP, false
		evt.setStatus evt.ULTRAPASSAGEM, false
		evt.setStatus evt.COLETA_NITRO, false
		evt.setStatus evt.GASTA_NITRO, false
					
		'rotinas
		kev.atualiza
		retorna = inputGeral or (game_mode = GM_DEMO and tmp.getMS(tmp.TOTAL) > DEMO_TIMEOUT) 'demo sai sozinho
		cc.processa
		car.controles
		car.fisica		
		tmp.atualiza
		sons
		graficos
		
		'demo
		if game_mode = GM_DEMO then
			if tmp.pisca then
				fnt.pinta -1, 7, "p na tbua", 0, true
			else
				fnt.pinta -1, 7, "p na tbua", 4, true
			end if
		
			select case (tmp.getMS(tmp.TOTAL) / 4000) mod 5 'cada frase tem 4 segundos
				case 0: t = ">>> modo demonstrao <<<"
				case 1: t = "aperte esc para jogar!"
				case 2: t = trk(trk_index).getNomeCompleto + " - melhor tempo: " + tmp.formata(tmp.getMS(tmp.RECORDE))
				case 3: t = "recorde de voltas em modo arcade: " + str(tmp.getRecordeVoltas)
				case 4: t = "winners do not use drugs"
			end select
			fnt.pinta -1, 23, t, 1
		
		'jogo normal
		else
			'piloto automtico
			if evt.getStatus(evt.AUTO_PILOT) then
				if tmp.getVolta = 0 then
					i = tamanhoCircuito - int(car.getCoord) + 1
					select case i
						case is > (tamanhoCircuito / 2)
							'nada
						case is <= 3
							fnt.pintaNumero 154, 120, str(i)
							if not voc_tocou(i) then	
								sfx_voc(i).toca
								voc_tocou(i) = true
							end if
						case else
							fnt.mensagem "largada em movimento!", 2
					end select
					
				elseif tmp.getVolta >= 1 and not evt.getStatus(evt.GAME_OVER) then
					evt.setStatus evt.AUTO_PILOT, false
					
					if not voc_tocou(0) then
						sfx_voc(0).toca 'go!
						voc_tocou(0) = true
					end if
				end if
			end if
			
			'game over
			if evt.getStatus(evt.GAME_OVER) then
				fnt.mensagem "fim do tempo!", 3
					
				if trk(trk_index).noite then
					cor = 0
				else
					cor = 1
				end if
					
				if tmp.getVolta = 1 then
					fnt.pinta -1, 15, "nenhuma volta completada", cor
				elseif tmp.getVolta = 2 then
					fnt.pinta -1, 07, "melhor tempo: " + tmp.formata(tmp.getMS(tmp.MELHOR)), cor
					fnt.pinta -1, 15, "uma volta completada", cor
				else
					fnt.pinta -1, 07, "melhor tempo: " + tmp.formata(tmp.getMS(tmp.MELHOR)), cor
					fnt.pinta -1, 15, str(tmp.getVolta - 1) + " voltas completadas", cor
				end if
				fnt.pinta -1, 23, "aperte ESC", cor
			
			'jogo ainda rolando
			elseif tmp.getVolta >= 1 then
				tmp.pintaHud
				car.pintaHud
			end if
		end if
		
		tela.atualiza
		fps.preciseSleep
	loop until retorna
	
	'atualiza
	trk(trk_index).salvaRecordes
end sub

function cena.inputGeral () as integer
	if kev.confereTecla(kev.K_PAUSA, kev.PRESSED) then
		pausa
	elseif kev.confereTecla(kev.K_RETORNA, kev.PRESSED) then
		return true 'flag para sair do gameLoop
	else
		return false
	end if	
end function

sub cena.pausa
	dim as integer i, j
	dim as uinteger pixcor
	dim res as tupla
	
	'pausa som
	paraSons
	
	'faz grficos
	graficos
	tela.efeitoTela tela.FX_PRETO_E_BRANCO, 255
	
	fnt.mensagem "pausa", 3
	tela.atualiza
	
	'espera input
	do
		kev.atualiza
		fps.atualiza
		sleep 50, 1
	loop until kev.confereTecla(kev.K_PAUSA, kev.PRESSED) or kev.confereTecla(kev.K_RETORNA, kev.PRESSED)
	
	'reinicia som
	iniciaSons
end sub

sub cena.iniciaSons
	'atualiza
	sons

	sfx_motor.toca
	sfx_derrapagem.toca
	sfx_grama.toca
end sub

sub cena.paraSons
	sfx_motor.para
	sfx_derrapagem.para
	sfx_grama.para
end sub

sub cena.sons
	'motor
	sfx_motor.setPitch 0.2 + (5 * car.getRPM)
	
	'derrapagem
	if evt.getStatus(evt.DERRAPAGEM) and not evt.getStatus(evt.GRAMA) then
		sfx_derrapagem.setPitch 1
		sfx_derrapagem.setVolume 0.4
		
	elseif evt.getStatus(evt.PRE_DERRAPAGEM) and not evt.getStatus(evt.GRAMA) then
		sfx_derrapagem.setPitch 0.6
		sfx_derrapagem.setVolume 0.4
		
	else
		sfx_derrapagem.setVolume 0
	end if
	
	'grama
	if evt.getStatus(evt.GRAMA) and car.getVel > 0.02 then
		sfx_grama.setVolume 1
	else
		sfx_grama.setVolume 0
	end if
	
	'batida
	if evt.getStatus(evt.COLISAO) or evt.getStatus(evt.BUMP) then
		sfx_colisao.setVolume 1
		sfx_colisao.toca
	end if
	
	'nitro
	if evt.getStatus(evt.COLETA_NITRO) then sfx_pickup.toca
	if evt.getStatus(evt.GASTA_NITRO) then sfx_boost.toca
	
	'ultrapassagem
	if (car.getVel < 0.02 or car.getVel > 0.1) and evt.getStatus(evt.ULTRAPASSAGEM) then
		sfx_ultrapassagem.setPitch 1 + (0.15 * rnd) 'variao aleatria
		sfx_ultrapassagem.toca
	end if
	
	'checkpoint
	if game_mode = GM_ARCADE and evt.getStatus(evt.COMPLETA_VOLTA) and not evt.getStatus(evt.GAME_OVER) and tmp.getVolta > 1 then
		sfx_checkpoint.setVolume 1
		sfx_checkpoint.toca
	end if
end sub

'=======================================================================
'* GUI

function interface.getMusicaOn () as integer
	return musica_on
end function

sub interface.setMusicaOn (musica_on as integer)
	this.musica_on = musica_on
end sub

sub interface.fadeIn
	dim as double i = 255
	
	'inicia gerenciador de framerate
	fps.reinicia
	
	'faz fade-in
	while i > 0
		fps.atualiza
				
		tela.pintaSprite fundo, 0, 0
		tela.efeitoTela tela.FX_ESCURECE, i
		tela.atualiza
		
		bgmusic.toca
		
		fps.preciseSleep
		i = i - (VEL_FADE * fps.getFator)
	wend
end sub

sub interface.fadeOut
	dim as double i = 0
	
	'inicia gerenciador de framerate
	fps.reinicia

	'faz fade-out
	while i < 255
		fps.atualiza
		
		tela.pintaSprite fundo, 0, 0
		tela.efeitoTela tela.FX_ESCURECE, i
		tela.atualiza
		
		bgmusic.setVolume (1 - (i / 255))
		bgmusic.toca
		
		fps.preciseSleep
		i = i + (VEL_FADE * fps.getFator)
	wend

	'libera tudo para um novo load
	bgmusic.destroi
	fundo.destroi
	sombra.destroi
end sub

sub interface.chamaJogo
	fadeOut
	scn.cria
	scn.gameLoop
	scn.destroi
	
	'recarrega grficos
	fundo.carrega "gfx/scr/menu.bmp"
	sombra.cria 240, 9
	sombra.pintaLinha 0, 0, 239, 8, &h000000

	'recarrega msica
	bgmusic.carrega "mus/menu.ogg"
	
	'retorna ao menu
	fadeIn
end sub

function interface.menuInput as integer
	dim as integer i, j, y, escolha, cor, valor
	escolha = lista.getDefault
	dim as longint timeout = 0
		
	do
		'grficos
		tela.pintaSprite fundo, 0, 0
						
		'texto
		fnt.pinta -1, 51, string(len(lista.getTitulo), "_"), 3, true
		fnt.pinta -1, 50, lista.getTitulo, 0, true
		
		y = 120 - ((lista.getMaxItens + 1) * 9 / 2)		
		for i = 0 to lista.getMaxItens
			if i = escolha then
				cor = 2
			else
				cor = 0
			end if
						
			tela.pintaSprite sombra, 39, y, 128 'transparente
			fnt.pinta -1, y, lista.getItem(i), cor
			
			y = y + 9
		next
		
		'preview do menu pintura
		if lista.getTitulo = "escolha a pintura" and escolha <= MAX_PALETES then
			pal.pintaPreview escolha, 127, y + 24
		end if
		
		'preview do menu circuito
		if (lista.getTitulo = "escolha o circuito" or lista.getTitulo = "recordes") and escolha <= MAX_CIRCUITOS then
			trk(escolha).pintaMapa 119, 158
		end if
		
		tela.atualiza
		
		'espera apertar uma tecla
		do
			kev.atualiza
			bgmusic.toca		
			sleep 5, 1
			
			'salta para demo se ficar ocioso
			if lista.getTitulo = "menu principal" then
				timeout = timeout + 5
				if timeout >= MENU_TIMEOUT then return 6
			end if
		loop until	kev.confereTecla(kev.K_UP, kev.DOWN) or _
					kev.confereTecla(kev.K_DOWN, kev.DOWN) or _
					kev.confereTecla(kev.K_ESCOLHE, kev.PRESSED) or _
					kev.confereTecla(kev.K_RETORNA, kev.PRESSED)
		
		'zera timeout do menu principal
		timeout = 0
		
		'interpreta input
		if kev.confereTecla(kev.K_UP, kev.DOWN) then
			if escolha > 0 then
				escolha = escolha - 1
				sfx_menu_tic.toca
			end if
			
		elseif kev.confereTecla(kev.K_DOWN, kev.DOWN) then
			if escolha < lista.getMaxItens then
				escolha = escolha + 1
				sfx_menu_tic.toca
			end if
			
		elseif kev.confereTecla(kev.K_ESCOLHE, kev.PRESSED) then
			valor = escolha
			if valor = lista.getMaxItens then
				sfx_menu_swoosh.toca
			else
				sfx_menu_bip.toca
			end if
			
			exit do
			
		elseif kev.confereTecla(kev.K_RETORNA, kev.PRESSED) then
			valor = lista.getMaxItens 'ltimo item sempre  o retornar
			sfx_menu_swoosh.toca
			
			exit do
		end if
				
		'intervalo at o prximo scroll
		for i = 1 to 3
			bgmusic.toca
			sleep 50, 1
		next
	loop

	return valor
end function

sub interface.menu
	dim escolha(0 to 4) as integer 'guarda cada caminho da rvore
	dim i as integer
	dim res as tupla

	'carrega grficos
	fundo.carrega "gfx/scr/menu.bmp"
	sombra.cria 240, 9
	sombra.pintaLinha 0, 0, 239, 8, &h000000

	'carrega msica
	bgmusic.carrega "mus/menu.ogg"
	
	fadeIn
	
	'comea rvore
	escolha(i) = 0
	
	do
		lista.nova "menu principal"
		lista.insereItem "corrida rpida"
		lista.insereItem "modo arcade"
		lista.insereItem "modo prtica"
		lista.insereItem "recordes"
		lista.insereItem "opes"
		lista.insereItem "ajuda"
		lista.insereItem "demonstrao"
		lista.insereItem "sair"
		lista.setDefault escolha(0)
		
		escolha(0) = menuInput
		escolha(1) = 0
		
		if escolha(0) = 0 or escolha(0) = 6 then
			if escolha(0) = 0 then
				scn.setGameMode scn.GM_ARCADE
			else
				scn.setGameMode scn.GM_DEMO
			end if
		
			'escolhas aleatrias			
			i = int(rnd * (MAX_CARROS + 1))
			car.setModelo i
			
			car.setPalete mdl(i).getPaleteDefault
			
			i = int(rnd * (MAX_CIRCUITOS + 1))
			scn.setCircuito i
			
			i = int(rnd * 4)
			scn.setOrientacao i
			
			chamaJogo
			
			'retorna som aps demo (ugly)
			scn.setGameMode scn.GM_ARCADE
			
		elseif escolha(0) = 1 or escolha(0) = 2 then
			scn.setGameMode escolha(0) - 1
			
			do
				lista.nova "menu corrida"
				lista.insereItem "escolha do carro"
				lista.insereItem "escolha do circuito"
				lista.insereItem "comear"
				lista.insereItem "(retornar)"
				lista.setDefault escolha(1)
			
				escolha(1) = menuInput
			
				if escolha(1) = 0 then
					lista.nova "escolha o modelo"
					for i = 0 to MAX_CARROS
						lista.insereItem mdl(i).getNome
					next
					lista.insereItem "(retornar)"
					lista.setDefault car.getModelo
				
					escolha(2) = menuInput
				
					if escolha(2) < lista.getMaxItens then
						if escolha(2) <> car.getModelo then
							car.setModelo escolha(2)
							car.setPalete mdl(escolha(2)).getPaleteDefault
						end if
					
						lista.nova "escolha a pintura"
						for i = 0 to MAX_PALETES
							lista.insereItem pal.getNome(i)
						next
						lista.insereItem "(retornar)"
						lista.setDefault car.getPalete
					
						escolha(3) = menuInput
					
						if escolha(3) < lista.getMaxItens then
							car.setPalete escolha(3)
						
							lista.nova "escolha o cmbio"
							lista.insereItem "automtico"
							lista.insereItem "manual"
							lista.insereItem "(retornar)"
							if car.getAutoGear then
								lista.setDefault 0
							else
								lista.setDefault 1
							end if
				
							escolha(4) = menuInput
					
							if escolha(4) = 0 then
								car.setAutoGear true
							elseif escolha(4) = 1 then
								car.setAutoGear false
							end if
						end if
					end if
					
				elseif escolha(1) = 1 then
					lista.nova "escolha o circuito"
					for i = 0 to MAX_CIRCUITOS
						lista.insereItem trk(i).getNomeCompleto
					next
					lista.insereItem "(retornar)"
					lista.setDefault scn.getCircuito
				
					escolha(2) = menuInput
				
					if escolha(2) < lista.getMaxItens then
						scn.setCircuito escolha(2)
												
						lista.nova "escolha a orientao"
						lista.insereItem "normal"
						lista.insereItem "espelhado"
						lista.insereItem "invertido"
						lista.insereItem "espelhado e invertido"
						lista.insereItem "(retornar)"
						lista.setDefault scn.getOrientacao
					
						escolha(3) = menuInput
						if escolha(3) < lista.getMaxItens then scn.setOrientacao escolha(3)
					end if
			
				elseif escolha(1) = 2 then
					chamaJogo
					
					'volta pro menu principal
					exit do
					
				else
					exit do
				end if
			loop
		
		elseif escolha(0) = 3 then
			escolha(1) = scn.getCircuito
		
			do
				lista.nova "recordes"
				for i = 0 to MAX_CIRCUITOS
					lista.insereItem trk(i).getNomeCompleto
				next
				lista.insereItem "(retornar)"
				lista.setDefault escolha(1)
				
				escolha(1) = menuInput
				
				if escolha(1) < lista.getMaxItens then
					trk(escolha(1)).preview
				else
					exit do
				end if
			loop
			
		elseif escolha(0) = 4 then
			do
				lista.nova "opes"
				lista.insereItem "controle de estabilidade"
				lista.insereItem "efeitos sonoros"
				lista.insereItem "msica do menu"
				lista.insereItem "detalhe grfico"
				lista.insereItem "resoluo da tela"
				lista.insereItem "limite de quadros p/ seg."
				lista.insereItem "(retornar)"
				lista.setDefault escolha(1)
				
				escolha(1) = menuInput
				
				if escolha(1) = 0 then
					lista.nova "controle automtico de estabilidade"
					lista.insereItem "ligado"
					lista.insereItem "desligado"
					lista.insereItem "(retornar)"
					
					if car.getSteerAid then
						lista.setDefault 0
					else
						lista.setDefault 1
					end if
					
					escolha(2) = menuInput
					if escolha(2) = 0 then
						car.setSteerAid true
					elseif escolha(2) = 1 then
						car.setSteerAid false
					end if
					
				elseif escolha(1) = 1 then
					lista.nova "efeitos sonoros"
					lista.insereItem "ligados"
					lista.insereItem "desligados"
					lista.insereItem "(retornar)"
					
					if scn.getSFXOn then
						lista.setDefault 0
					else
						lista.setDefault 1
					end if
					
					escolha(2) = menuInput
					if escolha(2) = 0 then
						scn.setSFXOn true
					elseif escolha(2) = 1 then
						scn.setSFXOn false
					end if
				
				elseif escolha(1) = 2 then
					lista.nova "msica do menu"
					lista.insereItem "ligada"
					lista.insereItem "desligada"
					lista.insereItem "(retornar)"
					
					if musica_on then
						lista.setDefault 0
					else
						lista.setDefault 1
					end if
					
					escolha(2) = menuInput
					if escolha(2) = 0 then
						setMusicaOn true
					elseif escolha(2) = 1 then
						setMusicaOn false
					end if
				
				elseif escolha(1) = 3 then
					lista.nova "nvel de detalhe grfico"
					lista.insereItem "mnimo"
					lista.insereItem "mdio"
					lista.insereItem "mximo"
					lista.insereItem "(retornar)"
					lista.setDefault scn.getLOD
										
					escolha(2) = menuInput
					if escolha(2) < lista.getMaxItens then scn.setLOD escolha(2)
				
				elseif escolha(1) = 4 then
					lista.nova "resoluo da tela"
					lista.insereItem "320*240 janela    "
					lista.insereItem "320*240 tela cheia"
					lista.insereItem "640*480 janela    "
					lista.insereItem "640*480 tela cheia"
					lista.insereItem "(retornar)"
					
					res = tela.getDimensoes 'ignora estado janela/fullscreen
					if res.x = 320 then
						i = 0
					else
						i = 2
					end if
					if tela.getFullscreen then i = i + 1
					lista.setDefault i
															
					escolha(2) = menuInput
					select case escolha(2)
						case 0: tela.setRes 320, 240, false
						case 1: tela.setRes 320, 240, true
						case 2: tela.setRes 640, 480, false
						case 3: tela.setRes 640, 480, true
					end select
				
				elseif escolha(1) = 5 then
					lista.nova "limite de quadros por segundo"
					lista.insereItem "24 fps"
					lista.insereItem "30 fps"
					lista.insereItem "60 fps"
					lista.insereItem "(retornar)"
					
					select case fps.getMaxFPS
						case 24: lista.setDefault 0
						case 30: lista.setDefault 1
						case else: lista.setDefault 2
					end select
					
					escolha(2) = menuInput
					select case escolha(2)
						case 0: fps.setMaxFPS 24
						case 1: fps.setMaxFPS 30
						case 2: fps.setMaxFPS 60
					end select
				
				else
					exit do
				end if
			loop
		
		elseif escolha(0) = 5 then
			ajuda
			
		else
			lista.nova "sair agora?"
			lista.insereItem "sim"
			lista.insereItem "no"
			lista.setDefault 0
			
			escolha(1) = menuInput
			if escolha(1) = 0 then
				fadeOut
				fim
			end if
		end if
	loop
end sub

sub interface.intro
	dim i as integer
	
	'carrega fundo
	fundo.carrega "gfx/scr/intro.bmp"
	
	'carrega msica
	bgmusic.carrega "mus/intro.ogg"
	
	'espera um tempo para estabelecer o vdeo
	sleep 1000, 1
	fadeIn	
		
	'still
	tela.pintaSprite fundo, 0, 0
	fnt.pinta -1, 231, "aperte enter", 1
	fnt.pinta -1, 1, "$ 2010-2011, thiago marques", 1
	fnt.pinta -1, 9, "verso 1.2", 1
	tela.atualiza	
		
	kev.esperaTecla
	fadeOut
end sub

sub interface.ajuda
	dim ajuda_teclado as imagem
	
	'carrega
	ajuda_teclado.carrega "gfx/scr/ajuda.bmp"
	
	'faz grficos
	tela.pintaSprite ajuda_teclado, 0, 0
	tela.atualiza
	
	'espera input
	kev.esperaTecla
	
	'libera memria
	ajuda_teclado.destroi	
end sub
